var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from "@angular/core";
import { ComponentApiService } from "./component/component-api.service";
import { ConfigApiService } from "./config/config-api.service";
import { CurrentUserApiService } from "./current-user/currentUser-api.service";
import { EventApiService } from "./event/event-api.service";
import { FileApiService } from "./file/file-api.service";
import { HttpApiService } from "./http/http-api.service";
import { LocalizationApiService } from "./localization/localization-api.service";
import { AdminMetadataApiService } from "./metadata/admin/admin-metadata-api.service";
import { MetadataApiService } from "./metadata/metadata-api.service";
import { ObjectApiService } from "./object/object-api.service";
import { PageAdminApiService } from "./page-admin/page-admin-api.service";
import { PageModelApiService } from "./page-model/page-model-api.service";
import { PageStateApiService } from "./page-state/page-state-api.service";
import { PropertyApiService } from "./property/property-api.service";
import { RefDataApiService } from "./reference-data/refData.service";
import { ResourceApiService } from "./resource/resource-api.service";
import { ClientSearchApiService } from "./search/client/client-search-api.service";
import { SearchApiService } from "./search/search-api.service";
import { SheetApiService } from "./sheet/sheet-api.service";
import { TabApiService } from "./tab/tab-api.service";
import { ThemeApiService } from "./theme/theme-api.service";
import { TraversalApiService } from "./traversal/traversal-api.service";
import { LifeCycleEvent } from "../application-life-cycle.service";
import { filter, take } from "rxjs/operators";
let ApiModule = class ApiModule {
    constructor(appBootstrapService, apiInitService) {
        this.appBootstrapService = appBootstrapService;
        this.apiInitService = apiInitService;
        this.appBootstrapService
            .getCurrentLifeCycleStage()
            .pipe(filter(lifeCycleEvent => lifeCycleEvent === LifeCycleEvent.InitComplete), take(1))
            .subscribe(() => {
            this.apiInitService.createSviApi();
        });
    }
};
ApiModule = __decorate([
    NgModule({
        providers: [
            AdminMetadataApiService,
            ClientSearchApiService,
            ComponentApiService,
            ConfigApiService,
            CurrentUserApiService,
            EventApiService,
            FileApiService,
            HttpApiService,
            LocalizationApiService,
            MetadataApiService,
            ObjectApiService,
            PageAdminApiService,
            PageModelApiService,
            PageStateApiService,
            PropertyApiService,
            RefDataApiService,
            ResourceApiService,
            SheetApiService,
            SearchApiService,
            TabApiService,
            ThemeApiService,
            TraversalApiService
        ]
    })
], ApiModule);
export { ApiModule };
