export declare type FieldType = "STRING" | "BOOLEAN" | "REFERENCEDATA" | "USER_GROUP" | "JSON" | DateDataType | NumberDataType;
export declare type NumberDataType = "SMALLINT" | "INTEGER" | "LONG" | "FLOAT" | "DOUBLE" | "NUMERIC";
export declare type DateDataType = "DATE" | "TIMESTAMP" | "TIMESTAMP_WITH_TIME_ZONE";
export interface UserGroup {
    id: string;
    type: "user" | "group";
}
export declare type FieldTypeToValue<Type extends FieldType> = Type extends "BOOLEAN" ? boolean : Type extends "STRING" | DateDataType | "REFERENCEDATA" ? string : Type extends NumberDataType ? number : Type extends "JSON" ? object : Type extends "USER_GROUP" ? UserGroup[] : never;
export declare type FieldValue = undefined | string | number | boolean | object | UserGroup | Date | ChildObject[] | null;
export declare type ChildObject = {
    id?: string;
    isNew?: boolean;
    fieldValues: Record<string, FieldValue>;
};
