/**
 * This API is available on the Toolbar Property Editor controls to handle property changes and trigger refreshes.
 */
export interface ToolbarPropertyApi {
    /**
     * Methods related to the entire page.
     */
    readonly page: {
        /**
         * Registers a function to be invoked whenever one of the calling toolbar control's properties change.
         * @method
         * @param handler The function to be invoked.
         * @returns A function that stops the handler from being invoked.
         */
        onPropertyChange(handler: (category: string, property: string, currentValue: any, previousValue: any) => void): () => void;
    };
}
