import { MetadataApi } from "../metadata-api";
export interface FieldTypeLabels {
    [type: string]: string;
}
/**
 * {@link MetadataApi} extension provides the functionality related to retrieval of metadata.
 * Additional methods are available only in the SAS Visual Investigator Admin Application.
 * Accessed from the window at window.sas.vi.metadata.
 * @extends MetadataApi
 */
export interface AdminMetadataApi extends MetadataApi {
    /**
     * @method
     * @description Gets the field data type labels.
     * @returns Object containing the field data type labels.
     */
    getFieldDataTypeLabels(): FieldTypeLabels;
}
