export interface I18nResources {
    [key: string]: string | I18nResources;
}
/**
 * This API provides the resource functionality in SAS Visual Investigator.
 * Accessed from the window at window.sas.vi.resource.
 */
export interface ResourceApi {
    /**
     * @method
     * @description Register a resource bundle with the Resource Service.
     * @param bundleName {string} Name for the bundle to be stored in the resource cache.
     * @param resources {I18nResources} Object containing the resources to be added for the bundle
     * specified by the bundleName parameter.
     */
    registerResourceBundle(bundleName: string, resources: I18nResources): void;
}
