/* tslint:disable */
/* eslint-disable */
// Generated using typescript-generator version 2.15.527 on 2023-07-17 19:52:59.

export interface SecuredApiMeta {
    experimental?: boolean;
    developmentStartYear?: number;
    developmentEndYear?: number;
    applicationVersion?: string;
    serviceId?: string;
    build?: SecuredBuild;
    apiVersion?: number;
}

export interface SecuredBuild {
    sourceId?: string;
    buildVersion?: string;
    applicationVersion?: string;
    sourceTimeStamp?: string;
    timeStamp?: string;
}

export interface Api extends Serializable {
    version?: number;
    links?: RestRepresentationsLink[];
}

export interface ApiMeta extends Serializable {
    build?: Build;
    experimental?: boolean;
    developmentStartYear?: number;
    developmentEndYear?: number;
    serviceId?: string;
    apiVersion?: number;
}

export interface ResourceMediaType {
    name?: string;
    version?: number;
    deprecated?: boolean;
    docUrl?: string;
}

export interface ResourceMediaTypes {
    mediaTypes?: ResourceMediaType[];
    version?: number;
}

export interface Build extends Serializable {
    sourceId?: string;
    buildVersion?: string;
    sourceTimeStamp?: string;
    applicationVersion?: string;
    timeStamp?: string;
}

export interface Count extends Serializable {
    version?: number;
    value?: number;
}

export interface ErrorCodes {
}

export interface ErrorResponse extends Serializable {
    errorCode?: number;
    message?: string;
    details?: string[];
    remediation?: string;
    errors?: ErrorResponse[];
    id?: string;
    links?: RestRepresentationsLink[];
    version?: number;
    httpStatusCode?: number;
    targetUri?: string;
}

export interface RestRepresentationsLink extends Serializable {
    method?: string;
    rel?: string;
    href?: string;
    uri?: string;
    type?: string;
    responseType?: string;
    itemType?: string;
    responseItemType?: string;
    title?: string;
}

export interface RestRepresentationsLinks extends Serializable {
    version?: number;
    links?: RestRepresentationsLink[];
}

export interface ModelConstants {
}

export interface ResourceAttributes extends Serializable {
    id?: string;
    version?: number;
    label?: string;
    description?: string;
    links?: RestRepresentationsLink[];
    attributes?: { [index: string]: any };
}

export interface Attribute {
    name?: string;
    value?: any;
    valueList?: any[];
}

export interface ResourceCollection<T> extends Serializable {
    links?: RestRepresentationsLink[];
    name?: string;
    accept?: string;
    start?: number;
    count?: number;
    items?: T[];
    limit?: number;
    version?: number;
}

export interface ResourceProperties extends Serializable {
    properties?: ResourceProperty[];
}

export interface ResourceProperty {
    name?: string;
    value?: string;
}

export interface ResourceSelection extends Serializable {
    id?: string;
    type?: string;
    template?: string;
    resources?: string[];
    links?: RestRepresentationsLink[];
    version?: number;
}

export interface RestRepresentationsResourceSummary extends TrackedResource, Serializable {
    id?: string;
    type?: string;
    name?: string;
    description?: string;
    typeDefName?: string;
    iconUri?: string;
    links?: RestRepresentationsLink[];
    version?: number;
}

export interface SASHeaders {
}

export interface ValidationResponse extends Serializable {
    version?: number;
    error?: ErrorResponse;
    links?: RestRepresentationsLink[];
    valid?: boolean;
}

export interface AbstractModifiableResource extends AbstractResource, ETaggable, TimeTrackedResource, ETagAndLastModifiedProvider {
    createdBy?: string;
    modifiedBy?: string;
}

export interface AbstractResource extends Serializable {
    links?: RestRepresentationsLink[];
    version?: number;
}

export interface ETagAndLastModifiedProvider extends ETaggable, LastModifiedProvider {
}

export interface ETaggable extends Preconditionable {
    etag?: string;
}

export interface LastModifiedProvider extends Preconditionable {
    lastModifiedHeaderDate?: Date;
}

export interface LastModifiedProviderFromModifiedTimeStamp extends LastModifiedProvider {
    modifiedTimeStamp?: Date;
}

export interface Preconditionable {
}

export interface TimeTrackedResource extends LastModifiedProviderFromModifiedTimeStamp {
    creationTimeStamp?: Date;
}

export interface TrackedResource extends Serializable, ETaggable, TimeTrackedResource, ETagAndLastModifiedProvider {
    createdBy?: string;
    modifiedBy?: string;
}

export interface DateDeserializer extends JsonDeserializer<Date> {
}

export interface DateSerializer extends JsonSerializer<Date> {
}

export interface InstantDeserializer extends JsonDeserializer<Date> {
}

export interface InstantSerializer extends JsonSerializer<Date> {
}

export interface Timestamp {
}

export interface Action extends ActionSummary {
    items?: ActionItem[];
}

export interface ActionItem {
}

export interface Constants {
}

export interface ActionSummary {
    actionId?: string;
    action?: string;
    actionType?: string;
    objectType?: string;
    objectId?: string;
    objectVersion?: string;
    createdBy?: string;
    createdAt?: string;
    links?: RestRepresentationsLink[];
    version?: number;
}

export interface ActionTableValue {
    value?: any;
    type?: ActionTableValueType;
}

export interface ActionType {
    actionType?: string;
    localizedMessage?: string;
}

export interface LabelActionItem extends ActionItem {
    type?: ActionItemType;
    label?: string;
    items?: ActionItem[];
    labelType?: LabelValueType;
}

export interface SubActionItem extends ActionItem {
    type?: ActionItemType;
    action?: string;
    items?: ActionItem[];
}

export interface TableActionItem extends ActionItem {
    type?: ActionItemType;
    action?: string;
    headings?: string[];
    rows?: ActionTableValue[][];
}

export interface DataContent {
    "@type": "Document" | "ResolvedEntity" | "DocumentIdentifier" | "DocumentLink" | "TransactionLink";
}

export interface Document extends DataContent {
    "@type": "Document" | "ResolvedEntity";
    objectTypeName?: string;
    objectTypeId?: number;
    objectTypeVersion?: number;
    id?: string;
    createdAt?: Date;
    lastUpdatedAt?: Date;
    validFrom?: Date;
    validTo?: Date;
    fieldValues?: { [index: string]: any };
    fileOperations?: AbstractFileOperationUnion[];
    displayLabel?: string;
}

export interface DocumentIdentifier extends DataContent {
    "@type": "DocumentIdentifier";
    objectTypeName?: string;
    id?: string;
}

export interface DocumentLink extends CommonsDataRelationship {
    "@type": "DocumentLink";
    qualifiedTypeName?: string;
}

export interface EntityReference {
    documentType?: string;
    documentId?: string;
    validFrom?: Date;
    validTo?: Date;
    compoundValues?: string[];
    label?: string;
}

export interface CommonsDataRelationship extends DataContent {
    "@type": "DocumentLink" | "TransactionLink";
    relationshipTypeName?: string;
    relationshipTypeVersion?: number;
    relationshipTypeLabel?: string;
    id?: string;
    createdAt?: Date;
    lastUpdatedAt?: Date;
    validFrom?: Date;
    validTo?: Date;
    displayLabel?: string;
    fromObjectTypeName?: string;
    fromObjectTypeVersion?: number;
    fromObjectId?: string;
    fromObjectDisplayLabel?: string;
    toObjectTypeName?: string;
    toObjectTypeVersion?: number;
    toObjectId?: string;
    toObjectDisplayLabel?: string;
    fieldValues?: { [index: string]: any };
}

export interface RelationshipIdentifier {
    fullyQualifiedId?: string;
    relationshipName?: string;
    fromObjectName?: string;
    toObjectName?: string;
}

export interface DataResolvedEntity extends Document {
    "@type": "ResolvedEntity";
    label?: string;
    compoundValues?: string[];
    references?: EntityReference[];
}

export interface TransactionLink extends CommonsDataRelationship {
    "@type": "TransactionLink";
}

export interface AbstractFileOperation {
    method?: MethodType;
}

export interface CreateFileOperation extends AbstractFileOperation {
    body?: FileAssociation;
}

export interface DeleteFileOperation extends AbstractFileOperation {
    id?: string;
}

export interface FileAssociation {
    version?: number;
    id?: string;
    name?: string;
    originalName?: string;
    category?: string;
    location?: string;
    type?: string;
    size?: number;
    description?: string;
    properties?: { [index: string]: any };
    uploadedAt?: Date;
    uploadedBy?: string;
    extractedContent?: string;
    displayOrder?: number;
    link?: boolean;
    isLink?: boolean;
}

export interface UpdateFileOperation extends AbstractFileOperation {
    body?: FileAssociation;
}

export interface ItemPublishResultDTO {
    type?: PublishItemType;
    label?: string;
    successful?: number;
    failed?: number;
    errors?: PublishErrorDTO[];
}

export interface PublishErrorDTO {
    name?: string;
    label?: string;
    message?: string;
}

export interface PublishResolution {
}

export interface SolutionPublishResultDTO {
    solutionName?: string;
    solutionLabel?: string;
    successful?: number;
    failed?: number;
    results?: ItemPublishResultDTO[];
    links?: RestRepresentationsLink[];
}

export interface AttachmentController {
}

export interface CatalogController {
}

export interface CommentController {
}

export interface ConditionController {
}

export interface ConfigServiceController {
}

export interface ControllerUriConstants {
}

export interface ControllerUtil {
}

export interface DataHubExceptionHandler {
}

export interface DataServicesController {
}

export interface DatahubHandlerExceptionResolver extends HandlerExceptionResolver, Ordered {
}

export interface DocumentController {
}

export interface DocumentControllerFilterUtil {
}

export interface DocumentFilterUtil {
}

export interface DocumentMetadataController {
}

export interface FileAssociationResponse extends FileAssociation {
    links?: RestRepresentationsLink[];
}

export interface FileController {
}

export interface FilterController {
}

export interface IconController {
    allIcons?: IconDTO[];
}

export interface LinkMetadataController {
}

export interface LinkWithBody<T> extends RestRepresentationsLink {
    body?: T;
}

export interface LockController {
}

export interface MetadataActivityRecorder {
}

export interface MetahubSharedExceptionHandler {
}

export interface PageController {
}

export interface ReferenceListController {
}

export interface RelationshipsController {
}

export interface ResolvedEntityController {
}

export interface ResolvedEntityUtilController {
}

export interface TransactionDataController {
}

export interface TransactionMetadataController {
    allTransactions?: TransactionDTO[];
}

export interface TraversalController {
}

export interface UtilityServicesController {
    supportedLocales?: LocalizedLocale[];
    defaultLocale?: LocalizedLocale;
}

export interface ActionController {
}

export interface AdminActiveHomepageController {
}

export interface AdminAsyncJobController {
}

export interface AdminCascadingReferenceDataController {
}

export interface AdminControlController {
}

export interface AdminDataStoreController {
}

export interface DataStoreCredentials {
    username?: string;
    password?: string;
}

export interface AdminElementBagController {
}

export interface AdminElementController {
    allElements?: ElementDTO[];
}

export interface AdminEntityController {
}

export interface AdminEntityUtilController {
}

export interface AdminIconController {
    allIcons?: IconDTO[];
}

export interface AdminMetadataCacheController {
    metadataCacheStatistics?: ResponseEntity<{ [index: string]: any }>;
    clientMetadataCacheStatistics?: ResponseEntity<CacheStats>;
}

export interface AdminNldStylingRuleController {
    rulesFromAllSources?: { [index: string]: any };
}

export interface AdminPageBuilderController {
}

export interface AdminReferenceListController {
}

export interface AdminRelationshipController {
}

export interface AdminRulesCacheController {
}

export interface AdminStoredObjectController {
}

export interface AdminTemplateController {
}

export interface AdminUtilController {
    allDataStoreNames?: string[];
}

export interface ClientApplicationController {
    allClientApplications?: ResourceCollection<ClientApplication>;
}

export interface SolutionController {
}

export interface TemplateTypeController {
    allTemplateTypes?: ResourceCollection<TemplateType>;
}

export interface AsyncJobException extends DataHubException {
}

export interface RestUtil {
}

export interface AuditableObject extends IdentifiableObject {
    createdBy?: string;
    createdAt?: Date;
    lastUpdatedBy?: string;
    lastUpdatedAt?: Date;
}

export interface CapabilityConstants {
}

export interface ConfigProperty extends Identifiable, NamedObject {
    values?: string[];
}

export interface Constant {
}

export interface ActionHistoryColumns {
}

export interface ConfigPropertyName {
}

export interface Length {
}

export interface QueryName {
}

export interface CoreCascadingReferenceData extends LocalizableObject, NamedObject, SolutionAssignedEntity {
    levels?: CoreReferenceList[];
}

export interface CoreCompound extends AuditableObject, Versioned {
    entity?: CoreEntity;
    elements?: CoreElement[];
}

export interface CoreDataField<O> extends LocalizableObject, Versioned, NamedObject {
    primaryKeyField?: boolean;
    displayIndex?: number;
    primaryKeySeqNo?: number;
    dataType?: any;
    columnName?: string;
    length?: number;
    precision?: number;
    scale?: number;
    unique?: boolean;
    autoGenerated?: boolean;
    required?: boolean;
    systemReserved?: boolean;
    constrainingListName?: string;
    allowMultipleSelections?: boolean;
    readOnly?: boolean;
    userSelectionStrategy?: UserSelectionStrategyType;
    indexedForSearch?: boolean;
    assignedTimeZone?: string;
    displayInTimeZone?: string;
    showTimeZone?: boolean;
    redacted?: boolean;
    useObjectAuthorization?: boolean;
    allowedRedactedFieldGroups?: RedactionRuleEntity[];
    userGroupSelectionField?: boolean;
    masked?: boolean;
    owner?: O;
    constrained?: boolean;
}

export interface CoreDataObject extends LocalizableObject, Versioned, NamedObject, SolutionAssignedEntity, Serializable {
    dataStore?: DataStore;
    tableName?: string;
    tableType?: string;
    cacheTimeoutSecs?: number;
    historyEnabled?: boolean;
    systemReserved?: boolean;
    lastUpdatedAtTimeFieldName?: string;
    createdAtTimeFieldName?: string;
    validFromFieldName?: string;
    validToFieldName?: string;
    allowedRedactedFieldGroups?: RedactionRuleEntity[];
    displayTextFields?: SortableNameReference[];
    cached?: boolean;
    fields?: CoreDataField<any>[];
}

export interface CoreDataObjectWithHistory extends CoreDataObject {
    historyTableName?: string;
    lastUpdatedByUserIdFieldName?: string;
    versionNumberFieldName?: string;
    createFlagHistoryColumnName?: string;
    deleteFlagHistoryColumnName?: string;
    updateFlagHistoryColumnName?: string;
}

export interface CoreElement extends LocalizableObject, Versioned, NamedObject, SolutionAssignedEntity {
    dataType?: any;
    displayable?: boolean;
    compounds?: CoreCompound[];
    mappedFields?: CoreStoredObjectField[];
}

export interface CoreEntity extends LocalizableObject, Versioned, NamedObject, Serializable, SolutionAssignedEntity {
    defaultRegularIcon?: CoreIcon;
    nodeShape?: string;
    nodeColor?: string;
    borderColor?: string;
    borderWidth?: number;
    scale?: number;
    displayTextElements?: SortableNameReference[];
    linkDisplayTextElements?: SortableNameReference[];
    useForNetworkBuild?: boolean;
    temporalSplitting?: boolean;
    compounds?: CoreCompound[];
    nodeDecorations?: NodeDecorationEntity[];
    additionalLabel?: string;
    requiresMultipleContributors?: boolean;
}

export interface CoreIcon extends AuditableObject, Versioned, NamedObject, Serializable, SolutionAssignedEntity {
    type?: IconType;
    bytes?: any;
    imageType?: IconImageType;
}

export interface CoreReferenceList extends LocalizableObject, NamedObject, SolutionAssignedEntity {
    archived?: boolean;
    alphabeticalSort?: boolean;
    maxCodeLength?: number;
    items?: CoreReferenceListField[];
    hierarchyLevel?: number;
    referenceListType?: ReferenceListType;
    parent?: CoreCascadingReferenceData;
}

export interface CoreReferenceListField extends LocalizableObject {
    parentList?: CoreReferenceList;
    code?: string;
    archived?: boolean;
    displayIndex?: number;
    parentCode?: string;
}

export interface CoreRelationship extends CoreDataObjectWithHistory {
    type?: RelationshipType;
    reverseName?: string;
    localizedReverseLabels?: LocalizedLabel[];
    required?: boolean;
    cardinality?: RelationshipCardinality;
    previousCardinality?: RelationshipCardinality;
    jobId?: string;
    fromObject?: CoreStoredObject;
    toObject?: CoreStoredObject;
    toObjectTypeFieldName?: string;
    linkedEntityTypes?: CoreStoredObject[];
    joinKeyFieldName?: string;
    symmetric?: boolean;
    managed?: boolean;
    joinConditions?: BooleanExpressionUnion[];
    cascadeType?: CascadeType;
    sortCriteria?: SortCriteria;
    fields?: CoreRelationshipField[];
    deleteTableName?: string;
    useCustomIndex?: boolean;
    color?: string;
    width?: number;
    dashType?: string;
    styles?: LinkStyleEntity[];
    reverseLabel?: string;
    primaryKeyFields?: CoreRelationshipField[];
    heterogeneous?: boolean;
    internalHeterogeneous?: boolean;
    foreignKeyFieldNames?: string[];
    attributeFields?: CoreRelationshipField[];
    nonAttributeFieldNames?: string[];
    qualifiedName?: string;
    link?: boolean;
    readOnly?: boolean;
}

export interface CoreRelationshipField extends CoreDataField<CoreRelationship> {
    owner?: CoreRelationship;
    summaryDisplayIndex?: number;
    authorizedToRevealMasked?: MaskRevealAuthorizationEntityRelationship[];
}

export interface CoreStoredObject extends CoreDataObjectWithHistory {
    type?: DataObjectType;
    fields?: CoreStoredObjectField[];
    relationshipsFrom?: CoreRelationship[];
    relationshipsTo?: CoreRelationship[];
    transactionsFrom?: CoreTransaction[];
    transactionsTo?: CoreTransaction[];
    linkedRelationshipTypes?: CoreRelationship[];
    defaultRegularIcon?: CoreIcon;
    nodeShape?: string;
    nodeColor?: string;
    markerColor?: string;
    borderColor?: string;
    borderWidth?: number;
    scale?: number;
    elementGroupRoot?: boolean;
    indexedForSearch?: boolean;
    attachmentsIndexedForSearch?: boolean;
    enableCasDistributedDataLoad?: boolean;
    deleteTableName?: string;
    urnFormat?: string;
    urnLength?: number;
    urnStartValue?: number;
    urnType?: UrnType;
    requireSearchBeforeCreate?: boolean;
    mobileOfflineEnabled?: boolean;
    fileCategories?: FileCategoryEntity[];
    styles?: EntityStyleEntity[];
    nodeDecorations?: NodeDecorationEntity[];
    additionalLabel?: string;
    publishCode?: PublishCode;
    fieldMap?: { [index: string]: CoreStoredObjectField };
    primaryKeyFields?: CoreStoredObjectField[];
    quotedDeleteTableName?: string;
    urnsequential?: boolean;
    readOnly?: boolean;
}

export interface CoreStoredObjectField extends CoreDataField<CoreStoredObject> {
    owner?: CoreStoredObject;
    element?: CoreElement;
    requiredCondition?: string;
    requiredConditionType?: ObjectStateType;
    readOnlyCondition?: string;
    readOnlyConditionType?: ObjectStateType;
    cascadingReferenceDataName?: string;
    cascadingReferenceDataFilterByListName?: string;
    cascadingReferenceDataFilterByCode?: string;
    cascadingReferenceDataFilterByField?: string;
    authorizedToRevealMasked?: MaskRevealAuthorizationEntityStoredObject[];
}

export interface CoreTransaction extends CoreDataObject {
    fromObject?: CoreStoredObject;
    toObject?: CoreStoredObject;
    fields?: CoreTransactionField[];
    fromObjJoinCondition?: BooleanExpressionUnion;
    toObjJoinCondition?: BooleanExpressionUnion;
    fromObjectTypeFieldName?: string;
    toObjectTypeFieldName?: string;
    fromObjectRefFieldName?: string;
    toObjectRefFieldName?: string;
    lineWidthFieldName?: string;
    lineWidthFunctionType?: AggregateFunctionType;
    lineColorFieldName?: string;
    lineColorFunctionType?: AggregateFunctionType;
    primaryKeyFields?: CoreDataField<any>[];
    heterogeneous?: boolean;
    fullHeterogeneous?: boolean;
    fromHeterogeneous?: boolean;
    toHeterogeneousAndFromObjectIsIndexable?: boolean;
    fromHeterogeneousAndToObjectIsIndexable?: boolean;
    nonHeterogeneousAndBothSidesAreIndexable?: boolean;
    toHeterogeneous?: boolean;
}

export interface CoreTransactionField extends CoreDataField<CoreTransaction> {
    owner?: CoreTransaction;
    authorizedToRevealMasked?: MaskRevealAuthorizationEntityTransaction[];
}

export interface DataStore extends AuditableObject, Versioned, NamedObject {
    type?: DataStoreType;
    schemaName?: string;
    assignedTimeZone?: string;
    connectionType?: TYPE;
    host?: string;
    port?: string;
    databaseOrServiceName?: string;
    urlAppendedParameters?: string;
    advancedProperties?: { [index: string]: string };
    poolIntialSize?: number;
    poolMinIdle?: number;
    poolMaxIdle?: number;
    poolMaxActive?: number;
    testOnBorrow?: boolean;
    defaultSchemaName?: string;
    defaultDataStore?: boolean;
}

export interface FeatureConstants {
}

export interface FieldHeader {
    fieldId?: number;
    entityTypeId?: number;
    fieldName?: string;
    columnName?: string;
    fieldDataType?: string;
}

export interface FileCategoryEntity extends Serializable {
    name?: string;
    displayName?: string;
    allowMultiple?: boolean;
    required?: boolean;
    documentLockRequired?: boolean;
}

export interface HistoryInfo {
    historyInfoId?: number;
    itemRefId?: string;
    itemType?: ItemType;
    itemLabel?: string;
    operation?: Operation;
    ownerType?: string;
    ownerId?: string;
    ownerVersion?: string;
}

export interface Identifiable {
    id?: number;
}

export interface IdentifiableObject extends Identifiable {
}

export interface InjectableResource {
}

export interface LocalizableObject extends AuditableObject {
    localizedLabels?: LocalizedLabel[];
    localizedDescriptions?: LocalizedDescription[];
    label?: string;
    description?: string;
}

export interface LocalizedDescription extends AuditableObject, Versioned {
    locale?: Locale;
    description?: string;
}

export interface LocalizedLabel extends AuditableObject, Versioned {
    localeCd?: string;
    locale?: Locale;
    label?: string;
    type?: LabelType;
}

export interface MaskRevealAuthorizationEntity {
    uuid?: string;
    selectionTypeCd?: UserGroupType;
    selectionNm?: string;
}

export interface MaskRevealAuthorizationEntityFactory {
}

export interface MaskRevealAuthorizationEntityRelationship extends MaskRevealAuthorizationEntity {
    coreDataField?: CoreRelationshipField;
}

export interface MaskRevealAuthorizationEntityStoredObject extends MaskRevealAuthorizationEntity {
    coreDataField?: CoreStoredObjectField;
}

export interface MaskRevealAuthorizationEntityTransaction extends MaskRevealAuthorizationEntity {
    coreDataField?: CoreTransactionField;
}

export interface NamedObject {
    name?: string;
}

export interface PrimaryKeySeqNoComparators {
}

export interface CoreDataFieldComparator extends Comparator<CoreDataField<any>> {
}

export interface DataFieldDTOComparator extends Comparator<DataField> {
}

export interface QAuditableObject extends EntityPathBase<AuditableObject> {
    _super?: QIdentifiableObject;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    id?: NumberPath<number>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
}

export interface QConfigProperty extends EntityPathBase<ConfigProperty> {
    id?: NumberPath<number>;
    name?: StringPath;
    valueString?: StringPath;
}

export interface QCoreCascadingReferenceData extends EntityPathBase<CoreCascadingReferenceData> {
    _super?: QLocalizableObject;
    assignedSolution?: QSolutionEntity;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    id?: NumberPath<number>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    levels?: SetPath<CoreReferenceList, QCoreReferenceList>;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    name?: StringPath;
}

export interface QCoreCompound extends EntityPathBase<CoreCompound> {
    _super?: QAuditableObject;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    elements?: ListPath<CoreElement, QCoreElement>;
    entity?: QCoreEntity;
    id?: NumberPath<number>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    version?: NumberPath<number>;
}

export interface QCoreDataField extends EntityPathBase<CoreDataField<CoreDataObject>> {
    _super?: QLocalizableObject;
    allowedRedactedFieldGroups?: ListPath<RedactionRuleEntity, QRedactionRuleEntity>;
    allowMultipleSelections?: BooleanPath;
    assignedTimeZone?: StringPath;
    autoGenerated?: BooleanPath;
    columnName?: StringPath;
    constrainingListName?: StringPath;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    dataType?: EnumPath<any>;
    displayIndex?: NumberPath<number>;
    displayInTimeZone?: StringPath;
    id?: NumberPath<number>;
    indexedForSearch?: BooleanPath;
    isMasked?: BooleanPath;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    length?: NumberPath<number>;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    name?: StringPath;
    precision?: NumberPath<number>;
    primaryKeyField?: BooleanPath;
    primaryKeySeqNo?: NumberPath<number>;
    readOnly?: BooleanPath;
    redacted?: BooleanPath;
    required?: BooleanPath;
    scale?: NumberPath<number>;
    showTimeZone?: BooleanPath;
    systemReserved?: BooleanPath;
    unique?: BooleanPath;
    useObjectAuthorization?: BooleanPath;
    userSelectionStrategy?: EnumPath<UserSelectionStrategyType>;
    version?: NumberPath<number>;
}

export interface QCoreDataObject extends EntityPathBase<CoreDataObject> {
    _super?: QLocalizableObject;
    allowedRedactedFieldGroups?: ListPath<RedactionRuleEntity, QRedactionRuleEntity>;
    assignedSolution?: QSolutionEntity;
    cacheTimeoutSecs?: NumberPath<number>;
    createdAt?: DateTimePath<Date>;
    createdAtTimeFieldName?: StringPath;
    createdBy?: StringPath;
    dataStore?: QDataStore;
    displayTextString?: StringPath;
    historyEnabled?: BooleanPath;
    id?: NumberPath<number>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedAtTimeFieldName?: StringPath;
    lastUpdatedBy?: StringPath;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    systemReserved?: BooleanPath;
    tableName?: StringPath;
    validFromFieldName?: StringPath;
    validToFieldName?: StringPath;
    version?: NumberPath<number>;
}

export interface QCoreDataObjectWithHistory extends EntityPathBase<CoreDataObjectWithHistory> {
    _super?: QCoreDataObject;
    allowedRedactedFieldGroups?: ListPath<RedactionRuleEntity, QRedactionRuleEntity>;
    assignedSolution?: QSolutionEntity;
    cacheTimeoutSecs?: NumberPath<number>;
    createdAt?: DateTimePath<Date>;
    createdAtTimeFieldName?: StringPath;
    createdBy?: StringPath;
    createFlagHistoryColumnName?: StringPath;
    dataStore?: QDataStore;
    deleteFlagHistoryColumnName?: StringPath;
    displayTextString?: StringPath;
    historyEnabled?: BooleanPath;
    historyTableName?: StringPath;
    id?: NumberPath<number>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedAtTimeFieldName?: StringPath;
    lastUpdatedBy?: StringPath;
    lastUpdatedByUserIdFieldName?: StringPath;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    systemReserved?: BooleanPath;
    tableName?: StringPath;
    updateFlagHistoryColumnName?: StringPath;
    validFromFieldName?: StringPath;
    validToFieldName?: StringPath;
    version?: NumberPath<number>;
    versionNumberFieldName?: StringPath;
}

export interface QCoreElement extends EntityPathBase<CoreElement> {
    _super?: QLocalizableObject;
    assignedSolution?: QSolutionEntity;
    compounds?: ListPath<CoreCompound, QCoreCompound>;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    dataType?: EnumPath<any>;
    displayable?: BooleanPath;
    id?: NumberPath<number>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    mappedFields?: ListPath<CoreStoredObjectField, QCoreStoredObjectField>;
    name?: StringPath;
    version?: NumberPath<number>;
}

export interface QCoreEntity extends EntityPathBase<CoreEntity> {
    _super?: QLocalizableObject;
    additionalLabel?: StringPath;
    assignedSolution?: QSolutionEntity;
    borderColor?: StringPath;
    borderWidth?: NumberPath<number>;
    compounds?: ListPath<CoreCompound, QCoreCompound>;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    defaultRegularIcon?: QCoreIcon;
    displayTextString?: StringPath;
    id?: NumberPath<number>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    linkDisplayTextString?: StringPath;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    name?: StringPath;
    nodeColor?: StringPath;
    nodeDecorations?: ListPath<NodeDecorationEntity, QNodeDecorationEntity>;
    nodeShape?: StringPath;
    requiresMultipleContributors?: BooleanPath;
    scale?: NumberPath<number>;
    temporalSplitting?: BooleanPath;
    useForNetworkBuild?: BooleanPath;
    version?: NumberPath<number>;
}

export interface QCoreIcon extends EntityPathBase<CoreIcon> {
    _super?: QAuditableObject;
    assignedSolution?: QSolutionEntity;
    bytes?: ArrayPath<any, number>;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    id?: NumberPath<number>;
    imageType?: EnumPath<IconImageType>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    name?: StringPath;
    version?: NumberPath<number>;
}

export interface QCoreReferenceList extends EntityPathBase<CoreReferenceList> {
    _super?: QLocalizableObject;
    alphabeticalSort?: BooleanPath;
    archived?: BooleanPath;
    assignedSolution?: QSolutionEntity;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    hierarchyLevel?: NumberPath<number>;
    id?: NumberPath<number>;
    items?: ListPath<CoreReferenceListField, QCoreReferenceListField>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    maxCodeLength?: NumberPath<number>;
    name?: StringPath;
    parent?: QCoreCascadingReferenceData;
    referenceListType?: EnumPath<ReferenceListType>;
}

export interface QCoreReferenceListField extends EntityPathBase<CoreReferenceListField> {
    _super?: QLocalizableObject;
    archived?: BooleanPath;
    code?: StringPath;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    displayIndex?: NumberPath<number>;
    id?: NumberPath<number>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    parentCode?: StringPath;
    parentList?: QCoreReferenceList;
}

export interface QCoreRelationship extends EntityPathBase<CoreRelationship> {
    _super?: QCoreDataObjectWithHistory;
    allowedRedactedFieldGroups?: ListPath<RedactionRuleEntity, QRedactionRuleEntity>;
    assignedSolution?: QSolutionEntity;
    cacheTimeoutSecs?: NumberPath<number>;
    cardinality?: EnumPath<RelationshipCardinality>;
    cascadeType?: EnumPath<CascadeType>;
    color?: StringPath;
    createdAt?: DateTimePath<Date>;
    createdAtTimeFieldName?: StringPath;
    createdBy?: StringPath;
    createFlagHistoryColumnName?: StringPath;
    dashType?: StringPath;
    dataStore?: QDataStore;
    deleteFlagHistoryColumnName?: StringPath;
    deleteTableName?: StringPath;
    displayTextString?: StringPath;
    fields?: ListPath<CoreRelationshipField, QCoreRelationshipField>;
    fromObject?: QCoreStoredObject;
    historyEnabled?: BooleanPath;
    historyTableName?: StringPath;
    id?: NumberPath<number>;
    jobId?: StringPath;
    joinCondition1String?: StringPath;
    joinCondition2String?: StringPath;
    joinKeyFieldName?: StringPath;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedAtTimeFieldName?: StringPath;
    lastUpdatedBy?: StringPath;
    lastUpdatedByUserIdFieldName?: StringPath;
    linkedEntityTypes?: ListPath<CoreStoredObject, QCoreStoredObject>;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    localizedReverseLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    managed?: BooleanPath;
    name?: StringPath;
    previousCardinality?: EnumPath<RelationshipCardinality>;
    required?: BooleanPath;
    reverseName?: StringPath;
    sortCriteriaString?: StringPath;
    styles?: ListPath<LinkStyleEntity, QLinkStyleEntity>;
    symmetric?: BooleanPath;
    systemReserved?: BooleanPath;
    tableName?: StringPath;
    toObject?: QCoreStoredObject;
    toObjectTypeFieldName?: StringPath;
    updateFlagHistoryColumnName?: StringPath;
    useCustomIndex?: BooleanPath;
    validFromFieldName?: StringPath;
    validToFieldName?: StringPath;
    version?: NumberPath<number>;
    versionNumberFieldName?: StringPath;
    width?: NumberPath<number>;
}

export interface QCoreRelationshipField extends EntityPathBase<CoreRelationshipField> {
    _super?: QCoreDataField;
    allowedRedactedFieldGroups?: ListPath<RedactionRuleEntity, QRedactionRuleEntity>;
    allowMultipleSelections?: BooleanPath;
    assignedTimeZone?: StringPath;
    authorizedToRevealMasked?: ListPath<MaskRevealAuthorizationEntityRelationship, QMaskRevealAuthorizationEntityRelationship>;
    autoGenerated?: BooleanPath;
    columnName?: StringPath;
    constrainingListName?: StringPath;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    dataType?: EnumPath<any>;
    displayIndex?: NumberPath<number>;
    displayInTimeZone?: StringPath;
    id?: NumberPath<number>;
    indexedForSearch?: BooleanPath;
    isMasked?: BooleanPath;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    length?: NumberPath<number>;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    name?: StringPath;
    owner?: QCoreRelationship;
    precision?: NumberPath<number>;
    primaryKeyField?: BooleanPath;
    primaryKeySeqNo?: NumberPath<number>;
    readOnly?: BooleanPath;
    redacted?: BooleanPath;
    required?: BooleanPath;
    scale?: NumberPath<number>;
    showTimeZone?: BooleanPath;
    summaryDisplayIndex?: NumberPath<number>;
    systemReserved?: BooleanPath;
    unique?: BooleanPath;
    useObjectAuthorization?: BooleanPath;
    userSelectionStrategy?: EnumPath<UserSelectionStrategyType>;
    version?: NumberPath<number>;
}

export interface QCoreStoredObject extends EntityPathBase<CoreStoredObject> {
    _super?: QCoreDataObjectWithHistory;
    additionalLabel?: StringPath;
    allowedRedactedFieldGroups?: ListPath<RedactionRuleEntity, QRedactionRuleEntity>;
    assignedSolution?: QSolutionEntity;
    attachmentsIndexedForSearch?: BooleanPath;
    borderColor?: StringPath;
    borderWidth?: NumberPath<number>;
    cacheTimeoutSecs?: NumberPath<number>;
    createdAt?: DateTimePath<Date>;
    createdAtTimeFieldName?: StringPath;
    createdBy?: StringPath;
    createFlagHistoryColumnName?: StringPath;
    dataStore?: QDataStore;
    defaultRegularIcon?: QCoreIcon;
    deleteFlagHistoryColumnName?: StringPath;
    deleteTableName?: StringPath;
    displayTextString?: StringPath;
    elementGroupRoot?: BooleanPath;
    enableCasDistributedDataLoad?: BooleanPath;
    fields?: ListPath<CoreStoredObjectField, QCoreStoredObjectField>;
    fileCategories?: SetPath<FileCategoryEntity, QFileCategoryEntity>;
    historyEnabled?: BooleanPath;
    historyTableName?: StringPath;
    id?: NumberPath<number>;
    indexedForSearch?: BooleanPath;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedAtTimeFieldName?: StringPath;
    lastUpdatedBy?: StringPath;
    lastUpdatedByUserIdFieldName?: StringPath;
    linkedRelationshipTypes?: SetPath<CoreRelationship, QCoreRelationship>;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    markerColor?: StringPath;
    mobileOfflineEnabled?: BooleanPath;
    name?: StringPath;
    nodeColor?: StringPath;
    nodeDecorations?: ListPath<NodeDecorationEntity, QNodeDecorationEntity>;
    nodeShape?: StringPath;
    publishCode?: EnumPath<PublishCode>;
    relationshipsFrom?: ListPath<CoreRelationship, QCoreRelationship>;
    relationshipsTo?: ListPath<CoreRelationship, QCoreRelationship>;
    requireSearchBeforeCreate?: BooleanPath;
    scale?: NumberPath<number>;
    styles?: ListPath<EntityStyleEntity, QEntityStyleEntity>;
    systemReserved?: BooleanPath;
    tableName?: StringPath;
    transactionsFrom?: ListPath<CoreTransaction, QCoreTransaction>;
    transactionsTo?: ListPath<CoreTransaction, QCoreTransaction>;
    updateFlagHistoryColumnName?: StringPath;
    urnFormat?: StringPath;
    urnLength?: NumberPath<number>;
    urnStartValue?: NumberPath<number>;
    urnType?: EnumPath<UrnType>;
    validFromFieldName?: StringPath;
    validToFieldName?: StringPath;
    version?: NumberPath<number>;
    versionNumberFieldName?: StringPath;
}

export interface QCoreStoredObjectField extends EntityPathBase<CoreStoredObjectField> {
    _super?: QCoreDataField;
    allowedRedactedFieldGroups?: ListPath<RedactionRuleEntity, QRedactionRuleEntity>;
    allowMultipleSelections?: BooleanPath;
    assignedTimeZone?: StringPath;
    authorizedToRevealMasked?: ListPath<MaskRevealAuthorizationEntityStoredObject, QMaskRevealAuthorizationEntityStoredObject>;
    autoGenerated?: BooleanPath;
    cascadingReferenceDataFilterByCode?: StringPath;
    cascadingReferenceDataFilterByField?: StringPath;
    cascadingReferenceDataFilterByListName?: StringPath;
    cascadingReferenceDataName?: StringPath;
    columnName?: StringPath;
    constrainingListName?: StringPath;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    dataType?: EnumPath<any>;
    displayIndex?: NumberPath<number>;
    displayInTimeZone?: StringPath;
    element?: QCoreElement;
    id?: NumberPath<number>;
    indexedForSearch?: BooleanPath;
    isMasked?: BooleanPath;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    length?: NumberPath<number>;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    name?: StringPath;
    owner?: QCoreStoredObject;
    precision?: NumberPath<number>;
    primaryKeyField?: BooleanPath;
    primaryKeySeqNo?: NumberPath<number>;
    readOnly?: BooleanPath;
    readOnlyCondition?: StringPath;
    readOnlyConditionType?: EnumPath<ObjectStateType>;
    redacted?: BooleanPath;
    required?: BooleanPath;
    requiredCondition?: StringPath;
    requiredConditionType?: EnumPath<ObjectStateType>;
    scale?: NumberPath<number>;
    showTimeZone?: BooleanPath;
    systemReserved?: BooleanPath;
    unique?: BooleanPath;
    useObjectAuthorization?: BooleanPath;
    userSelectionStrategy?: EnumPath<UserSelectionStrategyType>;
    version?: NumberPath<number>;
}

export interface QCoreTransaction extends EntityPathBase<CoreTransaction> {
    _super?: QCoreDataObject;
    allowedRedactedFieldGroups?: ListPath<RedactionRuleEntity, QRedactionRuleEntity>;
    assignedSolution?: QSolutionEntity;
    cacheTimeoutSecs?: NumberPath<number>;
    createdAt?: DateTimePath<Date>;
    createdAtTimeFieldName?: StringPath;
    createdBy?: StringPath;
    dataStore?: QDataStore;
    displayTextString?: StringPath;
    fields?: ListPath<CoreTransactionField, QCoreTransactionField>;
    fromObject?: QCoreStoredObject;
    fromObjectRefFieldName?: StringPath;
    fromObjectTypeFieldName?: StringPath;
    fromObjJoinConditionString?: StringPath;
    historyEnabled?: BooleanPath;
    id?: NumberPath<number>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedAtTimeFieldName?: StringPath;
    lastUpdatedBy?: StringPath;
    lineColorFieldName?: StringPath;
    lineColorFunctionType?: EnumPath<AggregateFunctionType>;
    lineWidthFieldName?: StringPath;
    lineWidthFunctionType?: EnumPath<AggregateFunctionType>;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    name?: StringPath;
    systemReserved?: BooleanPath;
    tableName?: StringPath;
    toObject?: QCoreStoredObject;
    toObjectRefFieldName?: StringPath;
    toObjectTypeFieldName?: StringPath;
    toObjJoinConditionString?: StringPath;
    validFromFieldName?: StringPath;
    validToFieldName?: StringPath;
    version?: NumberPath<number>;
}

export interface QCoreTransactionField extends EntityPathBase<CoreTransactionField> {
    _super?: QCoreDataField;
    allowedRedactedFieldGroups?: ListPath<RedactionRuleEntity, QRedactionRuleEntity>;
    allowMultipleSelections?: BooleanPath;
    assignedTimeZone?: StringPath;
    authorizedToRevealMasked?: ListPath<MaskRevealAuthorizationEntityTransaction, QMaskRevealAuthorizationEntityTransaction>;
    autoGenerated?: BooleanPath;
    columnName?: StringPath;
    constrainingListName?: StringPath;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    dataType?: EnumPath<any>;
    displayIndex?: NumberPath<number>;
    displayInTimeZone?: StringPath;
    id?: NumberPath<number>;
    indexedForSearch?: BooleanPath;
    isMasked?: BooleanPath;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    length?: NumberPath<number>;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    name?: StringPath;
    owner?: QCoreTransaction;
    precision?: NumberPath<number>;
    primaryKeyField?: BooleanPath;
    primaryKeySeqNo?: NumberPath<number>;
    readOnly?: BooleanPath;
    redacted?: BooleanPath;
    required?: BooleanPath;
    scale?: NumberPath<number>;
    showTimeZone?: BooleanPath;
    systemReserved?: BooleanPath;
    unique?: BooleanPath;
    useObjectAuthorization?: BooleanPath;
    userSelectionStrategy?: EnumPath<UserSelectionStrategyType>;
    version?: NumberPath<number>;
}

export interface QDataStore extends EntityPathBase<DataStore> {
    _super?: QAuditableObject;
    advancedProperties?: MapPath<string, string, StringPath>;
    assignedTimeZone?: StringPath;
    connectionType?: EnumPath<TYPE>;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    databaseOrServiceName?: StringPath;
    host?: StringPath;
    id?: NumberPath<number>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    name?: StringPath;
    poolIntialSize?: NumberPath<number>;
    poolMaxActive?: NumberPath<number>;
    poolMaxIdle?: NumberPath<number>;
    poolMinIdle?: NumberPath<number>;
    poolTestOnBorrow?: BooleanPath;
    port?: StringPath;
    schemaName?: StringPath;
    urlAppendedParameters?: StringPath;
    version?: NumberPath<number>;
}

export interface QFieldHeader extends EntityPathBase<FieldHeader> {
    columnName?: StringPath;
    entityTypeId?: NumberPath<number>;
    fieldDataType?: StringPath;
    fieldId?: NumberPath<number>;
    fieldName?: StringPath;
}

export interface QFileCategoryEntity extends BeanPath<FileCategoryEntity> {
    allowMultiple?: BooleanPath;
    displayName?: StringPath;
    documentLockRequired?: BooleanPath;
    name?: StringPath;
    required?: BooleanPath;
}

export interface QIdentifiableObject extends EntityPathBase<IdentifiableObject> {
    id?: NumberPath<number>;
}

export interface QLocalizableObject extends EntityPathBase<LocalizableObject> {
    _super?: QAuditableObject;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    id?: NumberPath<number>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
}

export interface QLocalizedDescription extends EntityPathBase<LocalizedDescription> {
    _super?: QAuditableObject;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    description?: StringPath;
    id?: NumberPath<number>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    localeCd?: StringPath;
    version?: NumberPath<number>;
}

export interface QLocalizedLabel extends EntityPathBase<LocalizedLabel> {
    _super?: QAuditableObject;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    id?: NumberPath<number>;
    label?: StringPath;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    localeCd?: StringPath;
    version?: NumberPath<number>;
}

export interface QMaskRevealAuthorizationEntity extends EntityPathBase<MaskRevealAuthorizationEntity> {
    selectionNm?: StringPath;
    selectionTypeCd?: EnumPath<UserGroupType>;
    uuid?: StringPath;
}

export interface QMaskRevealAuthorizationEntityRelationship extends EntityPathBase<MaskRevealAuthorizationEntityRelationship> {
    _super?: QMaskRevealAuthorizationEntity;
    coreDataField?: QCoreRelationshipField;
    selectionNm?: StringPath;
    selectionTypeCd?: EnumPath<UserGroupType>;
    uuid?: StringPath;
}

export interface QMaskRevealAuthorizationEntityStoredObject extends EntityPathBase<MaskRevealAuthorizationEntityStoredObject> {
    _super?: QMaskRevealAuthorizationEntity;
    coreDataField?: QCoreStoredObjectField;
    selectionNm?: StringPath;
    selectionTypeCd?: EnumPath<UserGroupType>;
    uuid?: StringPath;
}

export interface QMaskRevealAuthorizationEntityTransaction extends EntityPathBase<MaskRevealAuthorizationEntityTransaction> {
    _super?: QMaskRevealAuthorizationEntity;
    coreDataField?: QCoreTransactionField;
    selectionNm?: StringPath;
    selectionTypeCd?: EnumPath<UserGroupType>;
    uuid?: StringPath;
}

export interface QRedactionRuleEntity extends EntityPathBase<RedactionRuleEntity> {
    groupName?: StringPath;
    ownerId?: NumberPath<number>;
    uuid?: StringPath;
}

export interface QRelationshipTypeHeader extends EntityPathBase<RelationshipTypeHeader> {
    fromObjectId?: NumberPath<number>;
    relationshipId?: NumberPath<number>;
    relationshipName?: StringPath;
    reverseRelationshipName?: StringPath;
    toObjectId?: NumberPath<number>;
}

export interface QSolutionEntity extends EntityPathBase<SolutionEntity> {
    _super?: QLocalizableObject;
    archived?: BooleanPath;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    id?: NumberPath<number>;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    localizedDescriptions?: ListPath<LocalizedDescription, QLocalizedDescription>;
    localizedLabels?: ListPath<LocalizedLabel, QLocalizedLabel>;
    name?: StringPath;
    resourceVersion?: NumberPath<number>;
}

export interface QTenantFailure extends EntityPathBase<TenantFailure> {
    dateCreated?: DateTimePath<Date>;
    dateUpdated?: DateTimePath<Date>;
    instanceId?: StringPath;
    stackTrace?: StringPath;
    tenancyState?: StringPath;
    tenantId?: StringPath;
}

export interface RedactionRuleEntity {
    ownerId?: number;
    groupName?: string;
}

export interface RelationshipTypeHeader {
    relationshipId?: number;
    fromObjectId?: number;
    toObjectId?: number;
    relationshipName?: string;
    reverseRelationshipName?: string;
}

export interface RelationshipTypeName {
    fromObject?: string;
    relationshipName?: string;
    qualifiedName?: string;
}

export interface ShortBooleanType extends UserType {
}

export interface SolutionAssignedEntity {
    assignedSolution?: SolutionEntity;
}

export interface SolutionEntity extends LocalizableObject, Serializable {
    name?: string;
    archived?: boolean;
    resourceVersion?: number;
}

export interface TenantFailure {
    instanceId?: string;
    tenantId?: string;
    tenancyState?: string;
    stackTrace?: string;
    dateCreated?: Date;
    dateUpdated?: Date;
}

export interface Versioned {
    version?: number;
}

export interface AbstractCoreFieldConverter<T, Y, O> extends LocalizableObjectConversionProcessor<T, Y> {
}

export interface ActiveHomepageConverter extends MetadataConverter<ActiveHomepageEntity, ActiveHomepage> {
}

export interface AuditableObjectConversionProcessor<T, U> {
}

export interface CascadingReferenceDataConverter extends LocalizableObjectConversionProcessor<CoreCascadingReferenceData, CascadingReferenceDataDTO>, MetadataConverter<CoreCascadingReferenceData, CascadingReferenceDataDTO> {
}

export interface CompoundConverter extends AuditableObjectConversionProcessor<CoreCompound, CompoundDTO>, MetadataConverter<CoreCompound, CompoundDTO> {
}

export interface DataObjectConversionProcessor<T, U> extends LocalizableObjectConversionProcessor<T, U> {
}

export interface DataStoreConverter extends AuditableObjectConversionProcessor<DataStore, DataStoreDTO>, MetadataConverter<DataStore, DataStoreDTO> {
}

export interface ElementConverter extends LocalizableObjectConversionProcessor<CoreElement, ElementDTO>, MetadataConverter<CoreElement, ElementDTO> {
}

export interface EntityConverter extends LocalizableObjectConversionProcessor<CoreEntity, EntityDTO>, MetadataConverter<CoreEntity, EntityDTO> {
}

export interface EntityTypeConverter extends DataObjectConversionProcessor<CoreStoredObject, StoredObjectDTO>, MetadataConverter<CoreStoredObject, StoredObjectDTO> {
}

export interface EntityTypeFieldConverter extends AbstractCoreFieldConverter<CoreStoredObjectField, StoredObjectFieldDTO, CoreStoredObject>, MetadataConverter<CoreStoredObjectField, StoredObjectFieldDTO> {
}

export interface FileCategoryConverter extends MetadataConverter<FileCategoryEntity, FileCategoryDTO> {
}

export interface HistoryInfoConverter {
}

export interface IconConverter extends AuditableObjectConversionProcessor<CoreIcon, IconDTO>, MetadataConverter<CoreIcon, IconDTO> {
}

export interface LocalizableObjectConversionProcessor<T, U> extends AuditableObjectConversionProcessor<T, U> {
}

export interface LocalizedDescriptionConverter extends AuditableObjectConversionProcessor<LocalizedDescription, LocalizedDescriptionDTO>, MetadataConverter<LocalizedDescription, LocalizedDescriptionDTO> {
}

export interface LocalizedLabelConverter extends AuditableObjectConversionProcessor<LocalizedLabel, LocalizedLabelDTO>, MetadataConverter<LocalizedLabel, LocalizedLabelDTO> {
}

export interface MetadataConverter<T, U> {
}

export interface MetadataConverterUtils {
}

export interface ReferenceListConverter extends LocalizableObjectConversionProcessor<CoreReferenceList, ReferenceListDTO>, MetadataConverter<CoreReferenceList, ReferenceListDTO> {
}

export interface ReferenceListFieldConverter extends LocalizableObjectConversionProcessor<CoreReferenceListField, ReferenceListFieldDTO>, MetadataConverter<CoreReferenceListField, ReferenceListFieldDTO> {
}

export interface RelationshipTypeConverter extends DataObjectConversionProcessor<CoreRelationship, RelationshipDTO>, MetadataConverter<CoreRelationship, RelationshipDTO> {
}

export interface RelationshipTypeFieldConverter extends AbstractCoreFieldConverter<CoreRelationshipField, RelationshipFieldDTO, CoreRelationship>, MetadataConverter<CoreRelationshipField, RelationshipFieldDTO> {
}

export interface SolutionConverter extends LocalizableObjectConversionProcessor<SolutionEntity, SolutionDTO>, MetadataConverter<SolutionEntity, SolutionDTO> {
}

export interface SummaryCascadingReferenceDataConverter extends CascadingReferenceDataConverter {
}

export interface SummaryReferenceListConverter extends LocalizableObjectConversionProcessor<CoreReferenceList, ReferenceListDTO>, MetadataConverter<CoreReferenceList, ReferenceListDTO> {
}

export interface SvgIconConverter extends AuditableObjectConversionProcessor<CoreIcon, SvgIconDTO>, MetadataConverter<CoreIcon, SvgIconDTO> {
}

export interface TransactionTypeConverter extends DataObjectConversionProcessor<CoreTransaction, TransactionDTO>, MetadataConverter<CoreTransaction, TransactionDTO> {
}

export interface TransactionTypeFieldConverter extends AbstractCoreFieldConverter<CoreTransactionField, TransactionFieldDTO, CoreTransaction>, MetadataConverter<CoreTransactionField, TransactionFieldDTO> {
}

export interface AsyncJobDTO {
    id?: string;
    type?: JobType;
    submittedBy?: string;
    submittedAt?: Date;
    parameters?: { [index: string]: any };
    tasks?: AsyncTaskDTO[];
}

export interface AsyncTaskDTO {
    id?: string;
    name?: string;
    description?: string;
    type?: TaskType;
    queuedAt?: Date;
    properties?: { [index: string]: any };
}

export interface AuditableObjectDTO extends Identifiable {
    createdBy?: string;
    createdAt?: Date;
    lastUpdatedBy?: string;
    lastUpdatedAt?: Date;
}

export interface CascadingReferenceDataDTO extends LocalizableObjectDTO, NamedObject, Comparable<CascadingReferenceDataDTO>, SolutionAssignedDTO {
    levels?: ReferenceListDTO[];
    links?: RestRepresentationsLink[];
    version?: number;
    solutionLabel?: string;
}

export interface ClientJSONView {
}

export interface Group {
}

export interface Admin {
}

export interface AdminAudit {
}

export interface AdminList {
}

export interface AdminOnly {
}

export interface Always {
}

export interface ExcludeFromExport {
}

export interface ExcludeFromExportList {
}

export interface ExportOnly {
}

export interface JsonViewGroupId {
}

export interface Localized {
}

export interface Public {
}

export interface PublicAudit {
}

export interface PublicList {
}

export interface Summary {
}

export interface View {
}

export interface AdminListView extends Always, ExcludeFromExportList, JsonViewGroupId, PublicList, AdminList, AdminOnly, Localized {
}

export interface AdminView extends Always, ExcludeFromExportList, ExcludeFromExport, JsonViewGroupId, PublicAudit, AdminAudit, PublicList, Public, AdminList, Admin, AdminOnly, Localized {
}

export interface ExportView extends Always, ExportOnly, PublicList, Public, AdminList, Admin {
}

export interface ExportWithAuditView extends ExportView, PublicAudit, AdminAudit {
}

export interface PublicListView extends Always, ExcludeFromExportList, JsonViewGroupId, PublicList, Localized {
}

export interface PublicView extends Always, ExcludeFromExportList, ExcludeFromExport, JsonViewGroupId, PublicAudit, PublicList, Public, Localized {
}

export interface SummaryView extends Summary {
}

export interface ColumnDTO extends NamedObject {
    dataType?: ColumnDataType;
    length?: number;
    precision?: number;
    scale?: number;
    required?: boolean;
    primaryKeyColumn?: boolean;
    ordinalPosition?: number;
    primaryKeySeqNo?: number;
}

export interface CompoundDTO extends AuditableObjectDTO, Compound, Versioned, Comparable<CompoundDTO> {
    elements?: ElementDTO[];
    elementNames?: string[];
}

export interface ConditionalFieldRule extends ConditionalRule {
}

export interface DTOUtil {
}

export interface DataFieldDTO extends LocalizableObjectDTO, DataField, Versioned, NamedObject {
    dataType?: string;
    userGroupSelection?: boolean;
    constrained?: boolean;
}

export interface DataObjectDTO extends LocalizableObjectDTO, DataObject, Versioned, NamedObject {
    tableType?: string;
    solutionLabel?: string;
    naturalKey?: string;
}

export interface DataObjectId {
    type?: MetadataObjectType;
    name?: string;
}

export interface DataObjectWithHistoryDTO extends DataObjectDTO {
    historyTableName?: string;
    lastUpdatedByUserIdFieldName?: string;
    versionNumberFieldName?: string;
    createFlagHistoryColumnName?: string;
    deleteFlagHistoryColumnName?: string;
    deleteTableName?: string;
    updateFlagHistoryColumnName?: string;
    historyManaged?: boolean;
}

export interface DataStoreDTO extends AuditableObjectDTO, Versioned, NamedObject {
    type?: DataStoreType;
    connectionType?: TYPE;
    schema?: string;
    host?: string;
    port?: string;
    databaseNameOrServiceName?: string;
    urlAppendedParameters?: string;
    advancedProperties?: { [index: string]: string };
    assignedTimeZone?: string;
    testOnBorrow?: boolean;
    initialSize?: number;
    maxIdle?: number;
    minIdle?: number;
    maxActive?: number;
    username?: string;
    connectionError?: string;
    defaultSchemaName?: string;
    url?: string;
    password?: string;
    reindexRequired?: boolean;
    postedTimestamp?: number;
    casDistributedDataLoadSupported?: boolean;
}

export interface DataStoreSupportedTypeDTO {
    type?: string;
    requiredFields?: string[];
    defaultAdditionalFields?: { [index: string]: string };
}

export interface ElementBagDTO {
    elements?: ElementDTO[];
}

export interface ElementDTO extends LocalizableObjectDTO, Element, Versioned, NamedObject, Comparable<ElementDTO>, SolutionAssignedDTO {
    mappedFields?: StoredObjectFieldDTO[];
    relatedEntities?: RelatedEntityDTO[];
    solutionLabel?: string;
}

export interface EntityCompoundStringDTO {
    entityName?: string;
    compoundOrderedElementsStr?: string;
}

export interface EntityDTO extends LocalizableObjectDTO, Entity, Versioned, NamedObject, Comparable<EntityDTO> {
    nodeDecoration?: NodeDecorationDTO;
    defaultRegularIcon?: IconDTO;
    compounds?: CompoundDTO[];
    solutionLabel?: string;
    icons?: IconDTO[];
}

export interface FieldValueDTO {
    raw?: any;
}

export interface FileCategoryDTO extends InjectableResource, FileCategory {
    filesExist?: boolean;
    templates?: string[];
}

export interface FileCategoryStatsDTO {
    fileCategoryName?: string;
    entityTypeName?: string;
    maxCountPerDocument?: number;
}

export interface HasLocale {
    locale?: Locale;
}

export interface HistoryInfoDTO {
    historyInfoId?: number;
    itemRefId?: string;
    itemType?: string;
    itemLabel?: string;
    operation?: string;
    ownerType?: string;
    ownerId?: string;
    ownerVersion?: string;
}

export interface IconDTO extends AuditableObjectDTO, Versioned, Icon, NamedObject, Comparable<IconDTO>, SolutionAssignedDTO {
    bytes?: any;
    solutionLabel?: string;
}

export interface IdentityRepresentationDTO {
    userGroupId?: string;
    userGroupName?: string;
}

export interface IncrementalLoadJobFilter extends JobFilter {
    startTime?: Date;
}

export interface JobFilter {
    type?: string;
}

export interface LinkSummaryDTO {
    relationshipId?: number;
    relationshipName?: string;
    relationshipQualifiedName?: string;
    relationshipLabel?: string;
    reverseRelationshipName?: string;
    reverseRelationshipLabel?: string;
    fromEntityTypeName?: string;
    fromEntityTypeLabel?: string;
    toEntityTypeName?: string;
    toEntityTypeLabel?: string;
    linkCount?: number;
}

export interface LocalizableObjectDTO extends AuditableObjectDTO, InjectableResource {
    label?: string;
    description?: string;
    localizedLabels?: LocalizedLabelDTO[];
    localizedDescriptions?: LocalizedDescriptionDTO[];
}

export interface LocalizedDescriptionDTO extends AuditableObjectDTO, HasLocale, Versioned, Comparable<LocalizedDescriptionDTO> {
    description?: string;
    localeCd?: string;
}

export interface LocalizedLabelDTO extends AuditableObjectDTO, HasLocale, Versioned, Comparable<LocalizedLabelDTO> {
    label?: string;
    localeCd?: string;
}

export interface ObjectDeletionWarningDTO {
    type?: string;
    name?: string;
}

export interface ReferenceListDTO extends LocalizableObjectDTO, NamedObject, Comparable<ReferenceListDTO>, SolutionAssignedDTO {
    archived?: boolean;
    maxCodeLength?: number;
    alphabeticalSort?: boolean;
    items?: ReferenceListFieldDTO[];
    hierarchyLevel?: number;
    referenceListType?: ReferenceListType;
    usedByField?: boolean;
    solutionLabel?: string;
}

export interface ReferenceListFieldDTO extends LocalizableObjectDTO, NamedObject {
    code?: string;
    archived?: boolean;
    displayIndex?: number;
    parentCode?: string;
}

export interface RelatedEntityDTO extends NamedObject {
    id?: number;
    relationshipTypes?: string[];
}

export interface RelationshipDTO extends DataObjectWithHistoryDTO, Relationship, Comparable<RelationshipDTO> {
    cascadeType?: CascadeType;
    sortCriteria?: SortCriteria;
    toObjectTypeFieldName?: string;
    joinKeyFieldName?: string;
    joinConditions?: BooleanExpressionUnion[];
    fields?: RelationshipFieldDTO[];
    localizedReverseLabels?: LocalizedLabelDTO[];
    useCustomIndex?: boolean;
    conditions?: ConditionDTO[];
    reindexRequired?: boolean;
}

export interface RelationshipFieldDTO extends DataFieldDTO, Comparable<RelationshipFieldDTO> {
}

export interface SolutionDTO extends LocalizableObjectDTO, NamedObject, Comparable<SolutionDTO> {
    archived?: boolean;
    resourceVersion?: number;
    version?: number;
    links?: RestRepresentationsLink[];
}

export interface StoredObjectDTO extends DataObjectWithHistoryDTO, StoredDataObject, Comparable<StoredObjectDTO> {
    indexedForSearch?: boolean;
    reindexRequired?: boolean;
    fields?: StoredObjectFieldDTO[];
    relationshipsFrom?: RelationshipDTO[];
    relationshipsTo?: RelationshipDTO[];
    transactionsFrom?: TransactionDTO[];
    transactionsTo?: TransactionDTO[];
    defaultRegularIcon?: IconDTO;
    allowElementGroupRootAssignment?: boolean;
    urnFormat?: string;
    urnLength?: number;
    urnStartValue?: number;
    urnType?: UrnType;
    publishCode?: PublishCode;
    fileCategories?: FileCategoryDTO[];
    conditions?: ConditionDTO[];
    icons?: IconDTO[];
}

export interface StoredObjectFieldDTO extends DataFieldDTO, Comparable<StoredObjectFieldDTO> {
    relatedElementName?: string;
    requiredConditionally?: ConditionalFieldRule;
    readOnlyConditionally?: ConditionalFieldRule;
    cascadingReferenceDataName?: string;
    cascadingReferenceDataFilterByListName?: string;
    cascadingReferenceDataFilterByCode?: string;
    cascadingReferenceDataFilterByField?: string;
}

export interface SvgIconDTO extends AuditableObjectDTO, Versioned, NamedObject {
    imageType?: IconImageType;
    xmlContent?: string;
    solutionName?: string;
}

export interface TableDTO extends NamedObject {
    schema?: string;
    type?: string;
    databaseProductName?: string;
    columns?: ColumnDTO[];
}

export interface TransactionDTO extends DataObjectDTO, Transaction, Comparable<TransactionDTO> {
    fromObjJoinCondition?: BooleanExpressionUnion;
    toObjJoinCondition?: BooleanExpressionUnion;
    fields?: TransactionFieldDTO[];
    transactionDateFieldName?: string;
}

export interface TransactionFieldDTO extends DataFieldDTO, Comparable<TransactionFieldDTO> {
}

export interface ActionConfigurationDTO extends Comparable<ActionConfigurationDTO> {
    documentType?: string;
    items?: ActionItemConfigurationDTO[];
}

export interface ActionItemConfigurationDTO extends Comparable<ActionItemConfigurationDTO> {
    documentType?: string;
    uuid?: string;
    attributes?: { [index: string]: any };
    disableRules?: { [index: string]: any };
    disableConditions?: QueryUnion;
    resources?: { [index: string]: any };
    order?: number;
    action?: string;
    control?: string;
}

export interface ConditionConfigurationDTO extends Comparable<ConditionConfigurationDTO> {
    ownerName?: string;
    items?: ConditionDTO[];
}

export interface ContextMappingConfigurationDTO extends Comparable<ContextMappingConfigurationDTO>, ValidatableContextMapping {
    documentType?: string;
    propertyMatch?: { [index: string]: any };
    conditions?: QueryUnion;
    templateName?: string;
    templateUUID?: string;
    mode?: PageMode;
    clientApplication?: string;
    publishCode?: PublishCode;
}

export interface ContextMappingGrouping {
    documentType?: string;
    clientApplication?: string;
    event?: string;
}

export interface ContextMappingNaturalKey {
    documentType?: string;
    event?: string;
    clientApplicationName?: string;
    conditions?: QueryUnion;
}

export interface ControlCategoryConfigurationDTO extends Comparable<ControlCategoryConfigurationDTO> {
    type?: string;
    displayName?: string;
    resourcedDisplayName?: string;
}

export interface ControlConfigurationDTO extends NamedObject, SolutionAssignedDTO, Comparable<ControlConfigurationDTO> {
    directiveName?: string;
    icon?: any;
    displayName?: string;
    displayNameResource?: string;
    controlDescription?: string;
    controlDescriptionResource?: string;
    propertiesTitle?: string;
    propertiesTitleResource?: string;
    directiveTemplate?: string;
    directive?: string;
    controlAttributes?: { [index: string]: any };
    controlCategory?: string;
    customControl?: boolean;
    requiredCapabilities?: string[];
}

export interface DocumentTypeWithClientApplication {
    documentType?: string;
    clientApplication?: string;
}

export interface ElementExportDTO extends ElementDTO {
}

export interface EmbeddedElementExportDTO extends ElementDTO {
}

export interface EmbeddedIconExportDTO extends IconDTO {
}

export interface EmbeddedStoredObjectFieldDTO extends StoredObjectFieldDTO {
}

export interface EntityExportDTO extends EntityDTO {
    iconDecoration?: string;
}

export interface GroupedContextMappingConfigurationDTO extends DocumentTypeWithClientApplication, Comparable<GroupedContextMappingConfigurationDTO>, SolutionAssignedDTO {
    mappings?: ContextMappingConfigurationDTO[];
    documentTypeLabel?: string;
    clientApplicationLabel?: string;
}

export interface IconExportDTO extends IconDTO {
}

export interface MetadataExportDTO extends ConfigTransportObject {
    solutions?: SolutionDTO[];
    icons?: IconExportDTO[];
    referenceLists?: ReferenceListDTO[];
    documents?: StoredObjectExportDTO[];
    links?: RelationshipDTO[];
    transactions?: TransactionDTO[];
    elements?: ElementExportDTO[];
    entities?: EntityExportDTO[];
    templates?: TemplateConfigurationDTO[];
    contextMappings?: GroupedContextMappingConfigurationDTO[];
    traversalDefinitions?: TraversalConfigurationDTO[];
    controlCategories?: ControlCategoryConfigurationDTO[];
    controls?: ControlConfigurationDTO[];
    conditions?: ConditionConfigurationDTO[];
    templateTypes?: TemplateType[];
    clientApplications?: ClientApplication[];
    actions?: PageAction[];
    actionItems?: ActionConfigurationDTO[];
    hierarchicalReferenceData?: CascadingReferenceDataDTO[];
}

export interface StoredObjectExportDTO extends StoredObjectDTO {
    iconDecoration?: string;
}

export interface TemplateConfigurationDTO extends NamedObject, Comparable<TemplateConfigurationDTO>, SolutionAssignedDTO {
    uuid?: string;
    template?: { [index: string]: any };
    metadata?: TemplateMetadataExportDTO;
    documentType?: string;
    linkedTraversals?: string[];
    templateType?: string;
    clientApplication?: string;
    linkedReferenceLists?: string[];
    fileCategories?: TemplateFileCategoryAssociationDTO[];
    conditions?: string[];
    publishCode?: PublishCode;
    active?: boolean;
}

export interface TemplateLinkExportDTO {
    templateUuid?: string;
    traversalUuid?: string;
}

export interface TemplateMetadataExportDTO {
    dataSources?: TemplateDataSource[];
    linkedTemplates?: TemplateLinkExportDTO[];
    workspaceEnabled?: boolean;
    insightsEnabled?: boolean;
    resources?: { [index: string]: string };
}

export interface TraversalConfigurationDTO extends SolutionAssignedDTO, Comparable<TraversalConfigurationDTO> {
    displayName?: string;
    uuid?: string;
    traversal?: { [index: string]: any };
}

export interface ActiveHomepageMetadataInternalAdapter extends ActiveHomepageOperations {
}

export interface ActiveHomepageOperations {
    all?: ActiveHomepage[];
}

export interface CascadingReferenceDataInternalAdapter extends CascadingReferenceDataOperations {
}

export interface CascadingReferenceDataOperations {
    all?: CascadingReferenceDataDTO[];
}

export interface DataFieldUtils {
}

export interface EntityTypeCoreMetadataInternalAdapter extends EntityTypeOperations {
}

export interface EntityTypeOperations {
    all?: StoredObjectDTO[];
}

export interface EntityTypeUtils {
}

export interface MetahubClientConfig {
}

export interface MetahubClientResponseErrorHandler extends DefaultResponseErrorHandler {
}

export interface MetahubClientUtils {
}

export interface ObjectTypeCoreMetadataInternalAdapter extends ObjectTypeOperations {
}

export interface ObjectTypeOperations {
}

export interface ReferenceListCoreMetadataInternalAdapter extends ReferenceListOperations {
}

export interface ReferenceListMetahubClient extends ReferenceListOperations {
}

export interface ReferenceListOperations {
}

export interface ReferenceListUtils {
}

export interface RelationshipTypeCoreMetadataInternalAdapter extends RelationshipTypeOperations {
}

export interface RelationshipTypeOperations {
    allHeterogeneousRelationshipTypes?: RelationshipDTO[];
    all?: RelationshipDTO[];
}

export interface RelationshipTypeUtils {
}

export interface TransactionTypeCoreMetadataInternalAdapter extends TransactionTypeOperations {
}

export interface TransactionTypeOperations {
    allHeterogeneousTransactionTypes?: TransactionDTO[];
    all?: TransactionDTO[];
}

export interface TransactionTypeUtils {
}

export interface MetahubClientDeserializationException extends MetahubClientException {
}

export interface MetahubClientException extends RuntimeException {
}

export interface MetahubResponseException extends MetahubClientException {
    error?: Error;
}

export interface DataObjectRuleSource extends RuleSource {
    dataObject?: DataObjectDTO;
    fieldConditionMetadataIncludingChildren?: { [index: string]: AbstractFieldConditionMetadata<any, any> };
}

export interface DataObjectRuleSourceTypeGroup extends RuleSourceTypeGroup<DataObjectRuleSource> {
}

export interface HomepageRuleSourceTypeGroup extends RuleSourceTypeGroup<RuleSource> {
}

export interface RuleSetKey extends Serializable, Comparable<RuleSetKey> {
    type?: RuleKeyType;
    key?: string;
}

export interface RuleSetKeyDeserializer extends KeyDeserializer {
}

export interface RuleSetKeySerializer extends JsonSerializer<RuleSetKey> {
}

export interface RuleSource {
    key?: RuleSetKey;
}

export interface RuleSourceTypeGroup<T> {
    type?: RuleKeyType;
    ruleSources?: T[];
}

export interface DataMaskingStrategy {
}

export interface DatahubQuery {
    filterCriteria?: FilterCriteria;
    sortCriteria?: SortCriteria;
    pagingOptions?: PagingOptions;
    history?: HistoryOptions;
    temporalOptions?: TemporalOptions;
    tableType?: QueryTableType;
    groupingCriteria?: GroupingCriteria;
    countRows?: boolean;
    depth?: number;
    includeDisplayLabel?: boolean;
    includeAuditObjects?: boolean;
    dataMaskingStrategy?: DataMaskingStrategy;
    selectColumnFields?: string[];
    selectAll?: boolean;
}

export interface EmptyResultsWherePredicate extends WherePredicate {
}

export interface EmptyWherePredicate extends WherePredicate {
}

export interface EntityKey {
    id?: string;
    map?: { [index: string]: any };
}

export interface EntityKeyBuilder {
}

export interface EntityKeyConverter {
}

export interface EntityKeyWithMetadata {
    entityKey?: EntityKey;
    entityType?: StoredObjectDTO;
}

export interface FilterCriteria {
    filters?: WherePredicate;
}

export interface GroupPredicate {
    fieldName?: string;
}

export interface GroupingCriteria {
    groupPredicates?: GroupPredicate[];
}

export interface HistoryOptions {
    version?: number;
    ownerVersion?: string;
    where?: { [index: string]: any };
}

export interface PagingOptions {
    start?: number;
    limit?: number;
}

export interface PartitionUtil {
}

export interface QueryResults<T> {
    totalResultCount?: number;
    items?: T[];
    pagingOptions?: PagingOptions;
}

export interface RemoveValuesDataMaskingStrategy extends DataMaskingStrategy {
}

export interface ReplaceWithDotsDataMaskingStrategy extends DataMaskingStrategy {
}

export interface SortCriteria {
    field?: FieldReference;
    sortOrder?: SortOrder;
    next?: SortCriteria;
}

export interface TemporalOptions {
    earliestValidFrom?: Date;
    latestValidFrom?: Date;
    earliestValidTo?: Date;
    latestValidTo?: Date;
    dateFieldName?: string;
}

export interface UnmaskedDataMaskingStrategy extends DataMaskingStrategy {
}

export interface WherePredicate {
    fields?: string[];
    operator?: PredicateOperator;
    values?: any;
    childPredicates?: WherePredicate[];
    logicalOperator?: PredicateLogicalOperator;
    rawPredicate?: string;
    raw?: boolean;
}

export interface WherePredicateExpressionVisitor extends AbstractExpressionVisitor<WherePredicate> {
    filter?: WherePredicate;
}

export interface ArithmeticExpression extends Expression {
    type: "ArithExpr";
    leftOperand?: ExpressionUnion;
    rightOperand?: ExpressionUnion;
    operator?: QueryExpressionArithmeticOperator;
}

export interface BooleanExpression extends Expression {
    type: "BoolExpr" | "Conditional" | "Logical";
}

export interface ConditionalExpression extends BooleanExpression {
    type: "Conditional";
    leftOperand?: ExpressionUnion;
    rightOperands?: ExpressionUnion[];
    operator?: ConditionalOperator;
}

export interface Expression {
    type: "ArithExpr" | "BoolExpr" | "Conditional" | "Logical" | "FieldRef" | "Function" | "Literal" | "NamedParam" | "StrExpr";
}

export interface FieldReference extends Expression {
    type: "FieldRef";
    objectName?: string;
    fieldName?: string;
}

export interface FunctionCall extends Expression {
    type: "Function";
    functionName?: FunctionName;
    arguments?: ExpressionUnion[];
}

export interface Literal extends Expression {
    type: "Literal";
    value?: any;
}

export interface LogicalExpression extends BooleanExpression {
    type: "Logical";
    leftOperand?: ExpressionUnion;
    rightOperand?: ExpressionUnion;
    operator?: QueryExpressionLogicalOperator;
}

export interface NamedParameter extends Expression {
    type: "NamedParam";
    parameterName?: string;
}

export interface StringExpression extends Expression {
    type: "StrExpr";
    leftOperand?: ExpressionUnion;
    rightOperand?: ExpressionUnion;
    operator?: StringOperator;
}

export interface BaseDocumentCollectionRequest extends Serializable {
    start?: number;
    limit?: number;
    includeDisplayLabel?: boolean;
    depth?: string;
    sortBy?: string;
}

export interface BulkOperationResult {
    id?: string;
    entityType?: string;
    operation?: MessageAction;
    error?: ErrorResponse;
}

export interface CascadingReferenceDataSummary {
    id?: number;
    name?: string;
    label?: string;
    levels?: ReferenceListSummary[];
    version?: number;
    links?: RestRepresentationsLink[];
    solutionName?: string;
    solutionLabel?: string;
}

export interface ChildVersion extends ChildVersionSummary {
    values?: VersionValue[];
}

export interface ChildVersionSummary extends VersionSummary {
    parentTypeName?: string;
    parentId?: string;
    parentVersion?: string;
}

export interface Compound {
    elements?: Element[];
    id?: number;
}

export interface ConditionalRule {
    objectState?: string;
    conditionId?: string;
}

export interface DataField {
    redacted?: AbstractRedactionRuleUnion;
    requiredConditionally?: ConditionalRule;
    readOnlyConditionally?: ConditionalRule;
    ownerName?: string;
    dataType?: any;
    primaryKeyField?: boolean;
    displayIndex?: number;
    primaryKeySeqNo?: number;
    unique?: boolean;
    autoGenerated?: boolean;
    systemReserved?: boolean;
    allowMultipleSelections?: boolean;
    userSelectionStrategy?: UserSelectionStrategyType;
    constrainingListName?: string;
    indexedForSearch?: boolean;
    assignedTimeZone?: string;
    displayInTimeZone?: string;
    showTimeZone?: boolean;
    masked?: boolean;
    authorizedToRevealMasked?: UserGroupChooserSelection[];
    columnName?: string;
    scale?: number;
    label?: string;
    length?: number;
    name?: string;
    id?: number;
    readOnly?: boolean;
    description?: string;
    precision?: number;
    required?: boolean;
}

export interface DataObject extends SolutionAssignedDTO {
    dataStoreDefaultSchemaName?: string;
    dataStoreAssignedTimeZone?: string;
    historyEnabled?: boolean;
    createdAtTimeFieldName?: string;
    validFromFieldName?: string;
    systemReserved?: boolean;
    allowedRedactedFieldGroups?: string[];
    validToFieldName?: string;
    lastUpdatedAtTimeFieldName?: string;
    displayTextFields?: SortableNameReference[];
    dataStoreName?: string;
    tableName?: string;
    label?: string;
    name?: string;
    fields?: DataField[];
    id?: number;
    readOnly?: boolean;
    version?: number;
    description?: string;
}

export interface DocumentAndLink {
    document?: EnrichedDocument;
    documentLink?: DocumentLink;
}

export interface DocumentFilterRequest extends BaseDocumentCollectionRequest {
    filter?: string;
}

export interface DocumentIdRequest extends BaseDocumentCollectionRequest {
    documentIds?: string[];
}

export interface Element {
    dataType?: any;
    mappedFields?: DataField[];
    displayable?: boolean;
    label?: string;
    name?: string;
    id?: number;
}

export interface EnrichedDocument {
    objectTypeName?: string;
    objectTypeId?: number;
    objectTypeVersion?: number;
    id?: string;
    fieldValues?: { [index: string]: any };
    displayLabel?: string;
    createdAt?: Date;
    lastUpdatedAt?: Date;
    validFrom?: Date;
    validTo?: Date;
    sheets?: Sheet[];
    comments?: Comment[];
    fileOperations?: AbstractFileOperationUnion[];
    fieldRestrictions?: { [index: string]: any };
    attachmentsCount?: number;
}

export interface Entity extends SolutionAssignedDTO {
    defaultMapIcon?: Icon;
    defaultRegularIcon?: Icon;
    nodeColor?: string;
    nodeShape?: string;
    markerColor?: string;
    borderColor?: string;
    borderWidth?: number;
    useForNetworkBuild?: boolean;
    temporalSplitting?: boolean;
    displayTextElements?: SortableNameReference[];
    linkDisplayTextElements?: SortableNameReference[];
    requiresMultipleContributors?: boolean;
    compounds?: Compound[];
    publishCode?: PublishCode;
    scale?: number;
    label?: string;
    name?: string;
    id?: number;
}

export interface Error {
    httpStatusCode?: number;
    errorCode?: string;
    message?: string;
    details?: string[];
    remediation?: string;
    links?: RestRepresentationsLink[];
    stackTrace?: string;
    version?: number;
}

export interface FieldMaskingConfigDTO {
    currentUserIsAuthorizedToReveal?: boolean;
}

export interface Icon {
    imageLocation?: string;
    imageType?: IconImageType;
    id?: number;
    type?: IconType;
}

export interface LinkBulkOperationResult {
    id?: string;
    relationshipTypeName?: string;
    fromEntityType?: string;
    fromId?: string;
    toEntityType?: string;
    toId?: string;
    operation?: MessageAction;
    error?: ErrorResponse;
}

export interface MediaTypeConstants {
}

export interface ReferenceListSummary {
    version?: number;
    id?: number;
    name?: string;
    label?: string;
    maxCodeLength?: number;
    archived?: boolean;
    links?: RestRepresentationsLink[];
    referenceListType?: ReferenceListType;
    hierarchyLevel?: number;
    solutionName?: string;
    solutionLabel?: string;
}

export interface Relationship extends DataObject {
    toObjectTypeNames?: string[];
    summaryFields?: SortableNameReference[];
    heterogeneousLink?: boolean;
    linkFields?: { [index: string]: string }[];
    joinTableName?: string;
    reverseName?: string;
    reverseLabel?: string;
    fromObjectLabel?: string;
    toObjectLabel?: string;
    fromObjectName?: string;
    toObjectName?: string;
    cardinality?: RelationshipCardinality;
    previousCardinality?: RelationshipCardinality;
    symmetric?: boolean;
    dashType?: string;
    styles?: LinkStyleDTO[];
    qualifiedName?: string;
    managed?: boolean;
    width?: number;
    color?: string;
    type?: RelationshipType;
    required?: boolean;
}

export interface SheetCopySelection {
    objectTypeName?: string;
    objectId?: string;
    sheetIds?: number[];
    documentId?: DocumentId;
}

export interface SolutionAssignedDTO {
    solutionName?: string;
}

export interface SortableNameReference {
    name?: string;
    displayIndex?: number;
}

export interface StoredDataObject extends DataObject {
    defaultMapIcon?: Icon;
    nodeDecoration?: NodeDecorationDTO;
    defaultRegularIcon?: Icon;
    nodeColor?: string;
    nodeShape?: string;
    markerColor?: string;
    relationshipsFrom?: Relationship[];
    borderColor?: string;
    borderWidth?: number;
    attachmentsIndexedForSearch?: boolean;
    enableCasDistributedDataLoad?: boolean;
    relationshipsTo?: Relationship[];
    elementGroupRoot?: boolean;
    requireSearchBeforeCreate?: boolean;
    mobileOfflineEnabled?: boolean;
    fileCategories?: FileCategory[];
    styles?: EntityStyleDTO[];
    scale?: number;
    parentName?: string;
    type?: DataObjectType;
}

export interface Transaction extends DataObject {
    fromObjectName?: string;
    toObjectName?: string;
    toObjectTypeFieldName?: string;
    lineWidthFunctionType?: AggregateFunctionType;
    lineColorFieldName?: string;
    lineColorFunctionType?: AggregateFunctionType;
    fromObjectTypeFieldName?: string;
    fromObjectRefFieldName?: string;
    toObjectRefFieldName?: string;
    lineWidthFieldName?: string;
}

export interface Version extends VersionSummary {
    values?: VersionValue[];
}

export interface VersionSummary {
    typeName?: string;
    id?: string;
    version?: string;
    displayLabel?: string;
    operation?: string;
    createdBy?: string;
    createdAt?: Date;
    links?: RestRepresentationsLink[];
}

export interface VersionValue {
    name?: string;
    label?: string;
    previousVersionValue?: any;
    value?: any;
    type?: string;
    valueChanged?: boolean;
}

export interface CompoundImpl extends Compound {
}

export interface ConditionalFieldRuleImpl extends ConditionalRule {
}

export interface DataFieldImpl extends DataField {
    requiredConditionally?: ConditionalFieldRuleImpl;
    readOnlyConditionally?: ConditionalFieldRuleImpl;
}

export interface DataFilter {
    field?: string;
    value?: any;
}

export interface DataObjectImpl extends DataObject {
    solutionLabel?: string;
    indexedForSearch?: boolean;
}

export interface ElementImpl extends Element {
}

export interface EntityImpl extends Entity {
    solutionLabel?: string;
}

export interface FileCategory {
    allowMultiple?: boolean;
    documentLockRequired?: boolean;
    name?: string;
    displayName?: string;
    required?: boolean;
}

export interface FileCategoryImpl extends FileCategory {
}

export interface IconDecorationDTO {
    field?: string;
    position?: string;
}

export interface IconImpl extends Icon {
}

export interface ImplIdentifiable<T> {
    id?: T;
}

export interface NodeDecorationDTO {
    label?: string;
    icons?: IconDecorationDTO[];
}

export interface Paging {
    start?: number;
    count?: number;
}

export interface RelationshipImpl extends DataObjectImpl, Relationship {
}

export interface ResourceSummary {
    id?: number;
    uuid?: string;
    name?: string;
    dateCreated?: string;
    dateModified?: string;
    documentType?: string;
    solutionName?: string;
    solutionLabel?: string;
}

export interface ResourcedString {
    defaultText?: string;
    resourceKey?: string;
}

export interface Solution {
    id?: number;
    name?: string;
    solutionVersion?: string;
    archived?: boolean;
    resourceVersion?: number;
    version?: number;
    links?: RestRepresentationsLink[];
    label?: string;
    description?: string;
    createdBy?: string;
    lastUpdatedBy?: string;
    createdAt?: Date;
    lastUpdatedAt?: Date;
}

export interface Sorting {
    field?: string;
    ascending?: boolean;
}

export interface StoredDataObjectImpl extends DataObjectImpl, StoredDataObject {
}

export interface TemplateResourceSummary extends ResourceSummary {
    clientApplication?: string;
    templateType?: string;
    active?: boolean;
}

export interface TransactionImpl extends DataObjectImpl, Transaction {
}

export interface Traversal extends SolutionAssignedDTO {
    id?: number;
    uuid?: string;
    name?: string;
    traversalDefinition?: { [index: string]: any };
    solutionLabel?: string;
}

export interface Versions {
}

export interface Comment {
    id?: number;
    category?: string;
    author?: CommentUser;
    createDate?: Date;
    lastUpdatedAt?: Date;
    lastUpdatedBy?: string;
    detail?: string;
}

export interface CommentCategorySummary {
    category?: string;
    count?: number;
}

export interface CommentUser {
    id?: string;
    name?: string;
}

export interface AbstractFieldConditionMetadata<Y, T> {
    cycleDetector?: CycleDetector;
    ownerName?: string;
    parentObjectName?: string;
    owner?: Y;
}

export interface AbstractStyleDTO extends Comparable<AbstractStyleDTO>, Serializable {
    id?: string;
    conditionId?: string;
    evaluationOrder?: number;
}

export interface ConditionAssociationDTO {
    type?: string;
    association?: string;
}

export interface ConditionDTO extends Comparable<ConditionDTO>, ImplIdentifiable<string> {
    id?: string;
    version?: number;
    name?: string;
    description?: string;
    condition?: AbstractCondition<any>;
    referencedConditions?: string[];
    referencedFacts?: ReferencedFact[];
    ownerName?: string;
    referencedBy?: ConditionAssociationDTO[];
    creationTimeStamp?: Date;
    createdBy?: string;
    modifiedTimeStamp?: Date;
    modifiedBy?: string;
}

export interface CycleDetector {
    cycle?: boolean;
}

export interface EntityStyleDTO extends AbstractStyleDTO {
    iconName?: string;
    markerColor?: string;
    nodeColor?: string;
    borderColor?: string;
    borderWidth?: number;
    shape?: string;
    scale?: number;
    indicatorIconName?: string;
    indicatorIconPosition?: string;
    additionalLabel?: string;
}

export interface LinkStyleDTO extends AbstractStyleDTO {
    color?: string;
    width?: number;
    dashType?: string;
}

export interface ReferencedFact {
    factType?: ReferencedFactType;
    factPlaceholder?: string;
    factValue?: string;
}

export interface ArithmeticComparator<T> extends Serializable, BiFunction<T, T, boolean> {
}

export interface EqualityComparator extends ArithmeticComparator<any> {
}

export interface InequalityComparator extends ArithmeticComparator<any> {
}

export interface PresenceComparator extends Serializable, Function<any, boolean> {
}

export interface EqualityComparatorDeserializer extends JsonDeserializer<EqualityComparator> {
}

export interface EqualityComparatorSerializer extends JsonSerializer<EqualityComparator> {
}

export interface InequalityComparatorDeserializer extends JsonDeserializer<InequalityComparator> {
}

export interface InequalityComparatorSerializer extends JsonSerializer<InequalityComparator> {
}

export interface PresenceComparatorDeserializer extends JsonDeserializer<PresenceComparator> {
}

export interface PresenceComparatorSerializer extends JsonSerializer<PresenceComparator> {
}

export interface AbstractCondition<T> extends Serializable {
    parameters?: T[];
    type?: string;
}

export interface AbstractFieldCondition<T> extends AbstractCondition<T> {
}

export interface ArithmeticCondition extends AbstractFieldCondition<any>, FieldCondition {
    type: "eq";
    parameters?: any[];
}

export interface CompositeCondition extends AbstractCondition<AbstractCondition<any>> {
    type: "and";
    parameters?: AbstractCondition<any>[];
}

export interface CurrentUserMembershipCondition extends AbstractCondition<string> {
    type: "current_user_is_member_of";
    parameters?: string[];
}

export interface FieldCondition {
    value?: any;
    field?: string;
}

export interface NegateCondition extends AbstractCondition<AbstractCondition<any>> {
    type: "not";
    parameters?: AbstractCondition<any>[];
}

export interface PresenceCondition extends AbstractFieldCondition<any>, FieldCondition {
    type: "empty";
    parameters?: any[];
}

export interface ReferencedCondition extends AbstractCondition<string> {
    type: "cond";
    parameters?: string[];
}

export interface ContextMapping extends ImplIdentifiable<number>, ValidatableContextMapping {
    id?: number;
    conditions?: QueryUnion;
    templateId?: number;
    mode?: PageMode;
    clientApplication?: string;
    publishCode?: PublishCode;
    solutionLabel?: string;
    usedFields?: string[];
    usedGroups?: string[];
}

export interface ContextMappingOptions {
    toolbarEnabled?: boolean;
    templateId?: number;
    mode?: PageMode;
}

export interface Event {
    template?: Template;
    name?: string;
    metadata?: EventMetadata;
}

export interface EventMetadata {
    mode?: PageMode;
}

export interface ValidatableContextMapping extends SolutionAssignedDTO {
    fallbackToEvent?: string;
    templateId?: any;
    toolbarEnabled?: boolean;
    evaluateOrder?: number;
    docType?: string;
    uuid?: string;
    tag?: string;
    event?: string;
}

export interface Control extends ControlMetadata {
    createdAt?: Date;
    lastUpdatedAt?: Date;
    icon?: any;
    displayNameResource?: string;
    controlDescriptionResource?: string;
    propertiesTitleResource?: string;
    directiveTemplate?: string;
    directive?: string;
    version?: number;
}

export interface ControlCategory {
    type?: string;
    displayName?: ResourcedString;
    controls?: ControlMetadata[];
}

export interface ControlMetadata extends SolutionAssignedDTO {
    id?: number;
    category?: string;
    categoryDisplayName?: ResourcedString;
    name?: string;
    directiveName?: string;
    displayName?: ResourcedString;
    controlDescription?: ResourcedString;
    propertiesTitle?: ResourcedString;
    controlAttributes?: { [index: string]: any };
    customControl?: boolean;
    solutionLabel?: string;
    requiredCapabilities?: string[];
}

export interface RelateLinkDTO {
    fromDocument?: DocumentId;
    toDocuments?: RelateTo[];
    version?: number;
}

export interface RelateTo extends DocumentId {
    relationships?: string[];
}

export interface RelateOptionDTO {
    version?: number;
    relateToOptions?: RelateToOption[];
}

export interface RelateToOption {
    cardinalityStatus?: CardinalityStatus;
    relationship?: Relationship;
}

export interface BulkOperation<T, Y> {
    method?: MethodType;
    body?: T;
    id?: Y;
}

export interface BulkOperationsOutcome<T> {
    changedItems?: T[];
    affectedDocumentTypes?: string[];
}

export interface PageAction extends Comparable<PageAction>, SolutionAssignedDTO {
    actionName?: string;
    controlName?: string;
    displayName?: ResourcedString;
    clientApplication?: string;
    requiredCapabilities?: string[];
    customAction?: boolean;
    actionAttributes?: { [index: string]: any };
    solutionLabel?: string;
}

export interface PageActionItem {
    attrs?: ActionItemDetails;
}

export interface ActionItemConfig extends ImplIdentifiable<number> {
    id?: number;
    uuid?: string;
    actionName?: string;
    documentType?: string;
    attributes?: { [index: string]: any };
    resources?: { [index: string]: any };
    conditions?: QueryUnion;
    order?: number;
    usedFields?: string[];
    usedGroups?: string[];
}

export interface ActionItemDetails {
    uuid?: string;
    actionId?: number;
    controlId?: number;
    attributes?: { [index: string]: any };
    resources?: { [index: string]: any };
    actionName?: string;
    displayName?: string;
}

export interface ActionState extends Serializable {
}

export interface Actions {
    items?: PageActionItem[];
}

export interface FieldRestrictionTuple {
    fieldName?: string;
    restriction?: { [index: string]: any };
}

export interface FileRestrictionTuple {
    categoryName?: string;
    restriction?: { [index: string]: any };
}

export interface Page {
    id?: string;
    type?: string;
    typeId?: number;
    typeVersion?: number;
    documentVersion?: number;
    template?: Template;
    data?: TemplateData;
    sheetSummaries?: SheetSummary[];
    commentCount?: number;
    eventMetadata?: EventMetadata;
    linkedTemplateData?: LinkedTemplate[];
    actions?: Actions;
    fieldRestrictions?: { [index: string]: any };
    fileRestrictions?: { [index: string]: any };
    conditions?: ConditionDTO[];
}

export interface PageConfig {
    id?: number;
    propertyMatch?: { [index: string]: any };
    toolbarEnabled?: boolean;
    templateId?: number;
    mode?: PageMode;
    evaluateOrder?: number;
}

export interface PageRequestFlags {
    pageType?: PageTypeFlag;
}

export interface PageState extends Serializable {
    templateId?: number;
    toolbarEnabled?: boolean;
    actionState?: ActionState;
    pageMode?: PageMode;
}

export interface RecordMetadata {
    id?: string;
    type?: string;
    typeId?: number;
    typeVersion?: number;
    documentVersion?: number;
}

export interface UserGroupChooserSelection {
    type?: UserGroupType;
    id?: string;
}

export interface ActionItemRule {
    id?: number;
    actionName?: string;
    disableRules?: QueryUnion;
    requiredCapabilities?: string[];
}

export interface ArithmeticQuery extends Query, FieldCondition {
    type: "equals";
}

export interface CompositeQuery extends Query {
    type: "and";
    queries?: QueryUnion[];
}

export interface CurrentUserMembershipQuery extends Query {
    type: "current_user_is_member_of";
    value?: string;
    field?: string;
}

export interface Query {
    type: "equals" | "and" | "current_user_is_member_of";
}

export interface QueryUtils {
}

export interface DocumentId extends Serializable, ObjectTypeIdentifier {
    id?: string;
    uniqueId?: string;
}

export interface DocumentLabelSummary extends DocumentId {
    label?: string;
}

export interface ObjectTypeIdentifier {
    type?: string;
}

export interface Record {
    fields?: { [index: string]: any };
    id?: string;
    type?: string;
    typeVersion?: number;
    typeId?: number;
}

export interface RecordFilter extends ObjectTypeIdentifier {
    ids?: string[];
    fields?: string[];
}

export interface RecordFilters {
    recordFilters?: RecordFilter[];
}

export interface RelationshipId {
    relationshipName?: string;
    fromObjectTypeName?: string;
    toObjectTypeName?: string;
    relationshipQName?: string;
    id?: string;
}

export interface RelationshipIdBuilder {
}

export interface RelationshipIdByLinkedEntityKeys extends RelationshipId {
    fromObjectId?: string;
    toObjectId?: string;
}

export interface RelationshipIdByLinkedEntityRefs extends RelationshipId {
    fromObjectRef?: string;
    toObjectRef?: string;
    compositeKey?: string;
}

export interface RelationshipIdBySurrogateKey extends RelationshipId {
    surrogateId?: string;
}

export interface AbstractRedactionRule {
    useObjectAuthorization?: boolean;
    allowedGroups?: string[];
    type?: string;
}

export interface FullRedactionRule extends AbstractRedactionRule {
}

export interface Cell extends Serializable {
    type: "Image" | "Live" | "Static" | "Text";
    id?: number;
    row?: number;
    position?: number;
    height?: number;
    width?: number;
    version?: number;
    lastModified?: Date;
}

export interface CellTypeValues {
}

export interface ImageCell extends Cell {
    type: "Image";
    image?: string;
    annotations?: { [index: string]: any };
}

export interface LiveVisualizationCell extends Cell {
    type: "Live";
    documents?: DocumentId[];
    entities?: ResolvedEntity[];
    visualizationType?: VisualizationType;
    visualizationOptions?: { [index: string]: any };
    queryOptions?: { [index: string]: any };
    resultsPerPage?: number;
    filterModel?: { [index: string]: any };
    networkData?: { [index: string]: any };
}

export interface ResolvedEntity extends Serializable {
    type?: string;
    compound?: string;
}

export interface Sheet {
    id?: number;
    type?: SheetType;
    name?: string;
    version?: number;
    created?: Date;
    createdBy?: string;
    lastModified?: Date;
    lastModifiedBy?: string;
    tabOrder?: number;
    uxState?: { [index: string]: any };
    cells?: CellUnion[];
}

export interface SheetSummary {
    type?: SheetType;
    name?: string;
    id?: number;
    tabOrder?: number;
}

export interface Values {
}

export interface StaticVisualizationCell extends Cell {
    type: "Static";
    result?: { [index: string]: any };
    visualizationType?: VisualizationType;
}

export interface TextCell extends Cell {
    type: "Text";
    contents?: string;
}

export interface ActiveHomepage {
    id?: number;
    clientApplication?: string;
    templateUUID?: string;
    createdBy?: string;
    createdAt?: Date;
    lastUpdatedBy?: string;
    lastUpdatedAt?: Date;
    version?: number;
    links?: RestRepresentationsLink[];
}

export interface ClientApplication extends Comparable<ClientApplication> {
    name?: string;
    label?: string;
}

export interface LinkedTemplate {
    templateUuid?: string;
    traversalUuid?: string;
    traversal?: { [index: string]: any };
}

export interface Template extends SolutionAssignedDTO {
    id?: number;
    uuid?: string;
    name?: string;
    template?: { [index: string]: any };
    metadata?: TemplateMetadata;
    linkedTraversals?: string[];
    templateType?: string;
    clientApplication?: string;
    linkedReferenceLists?: string[];
    fileCategories?: TemplateFileCategoryAssociationDTO[];
    conditions?: string[];
    publishCode?: PublishCode;
    solutionLabel?: string;
    active?: boolean;
}

export interface TemplateData {
    id?: string;
    displayLabel?: string;
    fieldValues?: { [index: string]: any };
}

export interface TemplateDataSource {
    objectName?: string;
    fields?: string[];
}

export interface TemplateFileCategoryAssociationDTO {
    objectName?: string;
    fileCategories?: string[];
}

export interface TemplateKey {
    application?: string;
    name?: string;
}

export interface TemplateLink {
    templateUuid?: string;
    traversalUuid?: string;
}

export interface TemplateMetadata {
    dataSources?: TemplateDataSource[];
    linkedTemplates?: TemplateLink[];
    workspaceEnabled?: boolean;
    insightsEnabled?: boolean;
    workspaceCreationEnabled?: boolean;
    insightsCreationEnabled?: boolean;
    resources?: { [index: string]: string };
}

export interface TemplateType extends Comparable<TemplateType> {
    name?: string;
    label?: string;
}

export interface CellValidator {
}

export interface CommentValidator {
}

export interface EncodingRenderer extends HtmlStreamEventReceiver {
}

export interface EnrichedDocumentValidator {
}

export interface HtmlEncoder<T> {
    wrappedRenderer?: HtmlStreamEventReceiver;
    wrappedPolicy?: Policy;
}

export interface InputChannel<T> extends Policy {
}

export interface OutputChannel extends HtmlStreamEventReceiver {
}

export interface HtmlEncodingAppender extends Appendable {
}

export interface HtmlValidatorFactory {
}

export interface ImageCellValidator {
}

export interface LiveVisualizationCellValidator {
}

export interface RecordFiltersValidator {
}

export interface RecordIdValidator {
}

export interface ResolvedEntityValidator {
}

export interface SheetCopySelectionValidator {
}

export interface SheetValidator {
}

export interface StaticVisualizationCellValidator {
}

export interface TextCellValidator {
}

export interface ValidatorHtmlChangeListener extends HtmlChangeListener<string> {
}

export interface JsonMapWithNoHtmlValidator extends ConstraintValidator<JsonMapWithNoHtml, { [index: string]: any }> {
}

export interface SortByQueryParamValidator extends ConstraintValidator<SortByQueryParam, string> {
}

export interface StringWithNoHtmlValidator extends ConstraintValidator<StringWithNoHtml, string> {
}

export interface HtmlSanitizerConfig {
    htmlSanitizerProperties?: AdditionalHtmlSanitizerProperties;
}

export interface AdditionalHtmlSanitizerProperties {
    tags?: string;
}

export interface Job {
    version?: number;
    id?: string;
    name?: string;
    description?: string;
    parameters?: { [index: string]: any };
    tags?: string[];
    status?: Status;
    startedBy?: string;
    startedAt?: Date;
    endedAt?: Date;
    message?: string;
    tasks?: Task[];
    links?: RestRepresentationsLink[];
}

export interface JobV1 extends Job {
    startedTimeStamp?: Date;
    endedTimeStamp?: Date;
}

export interface Task {
    version?: number;
    parent?: string;
    id?: string;
    name?: string;
    description?: string;
    parameters?: { [index: string]: any };
    status?: Status;
    startedAt?: Date;
    endedAt?: Date;
    message?: string;
    subTasks?: Task[];
    links?: RestRepresentationsLink[];
}

export interface TaskV1 extends Task {
    startedTimeStamp?: Date;
    endedTimeStamp?: Date;
}

export interface CreatedEvent extends JobEvent {
    name?: string;
    description?: string;
    parameters?: { [index: string]: any };
}

export interface JobCreatedEvent extends CreatedEvent {
    tags?: string[];
    startedBy?: string;
    tasks?: TaskCreatedEvent[];
}

export interface JobEvent extends TypedPayload {
    version?: number;
    id?: string;
    status?: Status;
    startedAt?: Date;
    links?: RestRepresentationsLink[];
    eventTopic?: string;
    eventSubject?: string;
    job?: boolean;
}

export interface JobUpdatedEvent extends UpdatedEvent {
    startedBy?: string;
    tasks?: TaskUpdatedEvent[];
}

export interface TaskCreatedEvent extends CreatedEvent {
    parent?: string;
    subTasks?: TaskCreatedEvent[];
}

export interface TaskUpdatedEvent extends UpdatedEvent {
    parent?: string;
    subTasks?: TaskUpdatedEvent[];
}

export interface UpdatedEvent extends JobEvent {
    endedAt?: Date;
    message?: string;
    updateAllParentStatus?: boolean;
}

export interface LineageRelationship extends TrackedResource, ETaggable {
    resourceUri?: string;
    type?: string;
    relatedResourceUri?: string;
    source?: string;
    id?: string;
    referenceId?: string;
    relatedReferenceId?: string;
    version?: number;
    links?: RestRepresentationsLink[];
}

export interface ObjectContent extends ObjectId {
    fields?: { [index: string]: any };
}

export interface ObjectId extends Serializable {
    type?: string;
    id?: string;
}

export interface User {
    name?: string;
    groups?: string[];
}

export interface UserGroup extends Serializable {
    type?: CommonsSecurityBootStrapModelTypesUserGroupType;
    name?: string;
}

export interface EntityLevelAccessRequest {
    userId?: string;
    accessTypes?: AccessType[];
    documentTypes?: string[];
}

export interface EntityLevelAccessResponse {
    documentType?: string;
    access?: { [index: string]: boolean };
}

export interface RecordLevelAccessRequest {
    userId?: string;
    accessTypes?: AccessType[];
    documents?: ObjectId[];
}

export interface RecordLevelAccessResponse {
    documentType?: string;
    id?: string;
    access?: { [index: string]: boolean };
}

export interface Serializable {
}

export interface JsonDeserializer<T> extends NullValueProvider {
    delegatee?: JsonDeserializer<any>;
    knownPropertyNames?: any[];
    nullValue?: T;
    emptyAccessPattern?: AccessPattern;
    emptyValue?: any;
    objectIdReader?: ObjectIdReader;
    cachable?: boolean;
}

export interface ObjectIdReader extends Serializable {
    propertyName?: PropertyName;
    generator?: ObjectIdGenerator<any>;
    resolver?: ObjectIdResolver;
    idProperty?: SettableBeanProperty;
    deserializer?: JsonDeserializer<any>;
    idType?: JavaType;
}

export interface JsonSerializer<T> extends JsonFormatVisitable {
    unwrappingSerializer?: boolean;
    delegatee?: JsonSerializer<any>;
}

export interface HandlerExceptionResolver {
}

export interface Ordered {
    order?: number;
}

export interface LocalizedLocale {
    localeCd?: string;
    label?: string;
    default?: boolean;
}

export interface ResponseEntity<T> extends HttpEntity<T> {
    statusCodeValue?: number;
    statusCode?: HttpStatus;
}

export interface CacheStats {
}

export interface Throwable extends Serializable {
    cause?: Throwable;
    stackTrace?: StackTraceElement[];
    message?: string;
    suppressed?: Throwable[];
    localizedMessage?: string;
}

export interface StackTraceElement extends Serializable {
    classLoaderName?: string;
    moduleName?: string;
    moduleVersion?: string;
    methodName?: string;
    fileName?: string;
    lineNumber?: number;
    className?: string;
    nativeMethod?: boolean;
}

export interface DataHubException extends RuntimeException {
    errorCode?: ErrorCode;
    placeholderValues?: any[];
}

export interface NodeDecorationEntity extends Serializable {
    indicatorIconPosition?: string;
    indicatorIcon?: string;
}

export interface LinkStyleEntity extends AbstractStyleEntity {
    lineColor?: string;
    lineWeight?: number;
    dashType?: string;
}

export interface EntityStyleEntity extends AbstractStyleEntity {
    icon?: CoreIcon;
    markerColor?: string;
    nodeColor?: string;
    nodeBorderColor?: string;
    borderWidth?: number;
    shape?: string;
    scale?: number;
    indicatorIconPosition?: string;
    additionalLabel?: string;
    indicatorIcon?: string;
}

export interface Locale extends Cloneable, Serializable {
}

export interface DateTimePath<T> extends DateTimeExpression<T>, Path<T> {
}

export interface StringPath extends DslTypesDslStringExpression, Path<string> {
}

export interface NumberPath<T> extends NumberExpression<T>, Path<T> {
}

export interface AnnotatedElement {
    annotations?: Annotation[];
    declaredAnnotations?: Annotation[];
}

export interface Path<T> extends DslTypesExpression<T> {
    annotatedElement?: AnnotatedElement;
    root?: Path<any>;
    metadata?: PathMetadata;
}

export interface PathMetadata extends Serializable {
    element?: any;
    parent?: Path<any>;
    rootPath?: Path<any>;
    pathType?: PathType;
    root?: boolean;
    name?: string;
}

export interface Class<T> extends Serializable, GenericDeclaration, Type, AnnotatedElement {
}

export interface SetPath<E, Q> extends CollectionPathBase<E[], E, Q> {
}

export interface ListPath<E, Q> extends CollectionPathBase<E[], E, Q>, ListExpression<E, Q> {
}

export interface BooleanPath extends DslTypesDslBooleanExpression, Path<boolean> {
}

export interface EnumPath<T> extends EnumExpression<T>, Path<T> {
}

export interface QNodeDecorationEntity extends BeanPath<NodeDecorationEntity> {
    indicatorIcon?: StringPath;
    indicatorIconPosition?: StringPath;
}

export interface ArrayPath<A, E> extends SimpleExpression<A>, Path<A>, ArrayExpression<A, E> {
    elementType?: Class<E>;
}

export interface QLinkStyleEntity extends BeanPath<LinkStyleEntity> {
    _super?: QAbstractStyleEntity;
    condition?: QConditionEntity;
    dashType?: StringPath;
    evaluationOrder?: NumberPath<number>;
    id?: StringPath;
    lineColor?: StringPath;
    lineWeight?: NumberPath<number>;
}

export interface QEntityStyleEntity extends BeanPath<EntityStyleEntity> {
    _super?: QAbstractStyleEntity;
    additionalLabel?: StringPath;
    borderWidth?: NumberPath<number>;
    condition?: QConditionEntity;
    evaluationOrder?: NumberPath<number>;
    icon?: QCoreIcon;
    id?: StringPath;
    indicatorIcon?: StringPath;
    indicatorIconPosition?: StringPath;
    markerColor?: StringPath;
    nodeBorderColor?: StringPath;
    nodeColor?: StringPath;
    scale?: NumberPath<number>;
    shape?: StringPath;
}

export interface MapPath<K, V, E> extends MapExpressionBase<K, V, E>, Path<{ [index: string]: V }> {
    keyType?: Class<K>;
    valueType?: Class<V>;
}

export interface UserType {
    mutable?: boolean;
}

export interface ConfigTransportObject {
    handlerName?: string;
    schemaVersion?: string;
    resourceStrings?: { [index: string]: string };
    transportResourceStrings?: { [index: string]: string };
    resourceStringAccumulator?: ResourceStringAccumulator;
}

export interface DefaultResponseErrorHandler extends ResponseErrorHandler {
}

export interface RuntimeException extends Exception {
}

export interface KeyDeserializer {
}

export interface HtmlStreamEventReceiver {
}

export interface Policy extends HtmlStreamEventReceiver {
}

export interface Appendable {
}

export interface TypedPayload {
    payloadType?: string;
    eventType?: string;
}

export interface NullValueProvider {
    nullAccessPattern?: AccessPattern;
}

export interface PropertyName extends Serializable {
    namespace?: string;
    empty?: boolean;
    simpleName?: string;
}

export interface ObjectIdGenerator<T> extends Serializable {
    scope?: Class<any>;
}

export interface ObjectIdResolver {
}

export interface SettableBeanProperty extends ConcreteBeanPropertyBase, Serializable {
    objectIdInfo?: ObjectIdInfo;
    managedReferenceName?: string;
    valueTypeDeserializer?: TypeDeserializer;
    nullValueProvider?: NullValueProvider;
    propertyIndex?: number;
    creatorIndex?: number;
    injectableValueId?: any;
    injectionOnly?: boolean;
    valueDeserializer?: JsonDeserializer<any>;
    ignorable?: boolean;
}

export interface JavaType extends ResolvedType, Serializable, Type {
    keyType?: JavaType;
    typeHandler?: any;
    valueHandler?: any;
    enumImplType?: boolean;
    javaLangObject?: boolean;
    referencedType?: JavaType;
    contentValueHandler?: any;
    contentTypeHandler?: any;
    erasedSignature?: string;
    superClass?: JavaType;
    contentType?: JavaType;
    interfaces?: JavaType[];
    genericSignature?: string;
    bindings?: TypeBindings;
}

export interface JsonFormatVisitable {
}

export interface ConditionEntity extends Mergable<ConditionEntity> {
    id?: string;
    name?: string;
    description?: string;
    conditionJson?: { [index: string]: any };
    ownerName?: string;
    createdBy?: string;
    createdAt?: Date;
    lastUpdatedBy?: string;
    lastUpdatedAt?: Date;
    version?: number;
    referencedConditions?: ConditionReferenceEntity[];
    referencedFacts?: ConditionReferencedFactEntity[];
    condition?: AbstractCondition<any>;
}

export interface AbstractStyleEntity {
    id?: string;
    condition?: ConditionEntity;
    evaluationOrder?: number;
}

export interface Cloneable {
}

export interface Comparator<T> {
}

export interface DslTypesDslStringExpression extends LiteralExpression<string> {
}

export interface Annotation {
}

export interface GenericDeclaration extends AnnotatedElement {
    typeParameters?: TypeVariable<any>[];
}

export interface Type {
    typeName?: string;
}

export interface EntityPathBase<T> extends BeanPath<T>, EntityPath<T> {
}

export interface DslTypesDslBooleanExpression extends LiteralExpression<boolean>, Predicate {
}

export interface QAbstractStyleEntity extends BeanPath<AbstractStyleEntity> {
    condition?: QConditionEntity;
    evaluationOrder?: NumberPath<number>;
    id?: StringPath;
}

export interface QConditionEntity extends EntityPathBase<ConditionEntity> {
    associations?: ListPath<ConditionAssociationEntity, QConditionAssociationEntity>;
    conditionJson?: MapPath<string, any, SimplePath<any>>;
    createdAt?: DateTimePath<Date>;
    createdBy?: StringPath;
    description?: StringPath;
    id?: StringPath;
    lastUpdatedAt?: DateTimePath<Date>;
    lastUpdatedBy?: StringPath;
    name?: StringPath;
    ownerName?: StringPath;
    referencedConditions?: SetPath<ConditionReferenceEntity, QConditionReferenceEntity>;
    referencedFacts?: SetPath<ConditionReferencedFactEntity, QConditionReferencedFactEntity>;
    version?: NumberPath<number>;
}

export interface BeanPath<T> extends SimpleExpression<T>, Path<T> {
}

export interface ActiveHomepageEntity extends Serializable, StandardEntity {
    clientApplication?: ClientApplicationEntity;
    template?: TemplateEntity;
    createdBy?: string;
    createdAt?: Date;
    lastUpdatedBy?: string;
    lastUpdatedAt?: Date;
    version?: number;
}

export interface Comparable<T> {
}

export interface ResourceStringAccumulator {
    resourceStringsBySolution?: { [index: string]: { [index: string]: string } };
    transportResourceStrings?: { [index: string]: string };
}

export interface ResponseErrorHandler {
}

export interface Exception extends Throwable {
}

export interface AbstractExpressionVisitor<T> extends BaseVisitor {
    filter?: T;
}

export interface BiFunction<T, U, R> {
}

export interface Function<T, R> {
}

export interface HtmlChangeListener<T> {
}

export interface ConstraintValidator<A, T> {
}

export interface JsonMapWithNoHtml extends Annotation {
}

export interface SortByQueryParam extends Annotation {
}

export interface StringWithNoHtml extends Annotation {
}

export interface ObjectIdInfo {
    generatorType?: Class<ObjectIdGenerator<any>>;
    resolverType?: Class<ObjectIdResolver>;
    alwaysAsId?: boolean;
    scope?: Class<any>;
    propertyName?: PropertyName;
}

export interface TypeDeserializer {
    typeInclusion?: As;
    typeIdResolver?: TypeIdResolver;
    propertyName?: string;
    defaultImpl?: Class<any>;
}

export interface AnnotatedMember extends Annotated, Serializable {
    typeContext?: TypeResolutionContext;
    allAnnotations?: AnnotationMap;
    member?: Member;
    fullName?: string;
    declaringClass?: Class<any>;
}

export interface PropertyMetadata extends Serializable {
    mergeInfo?: MergeInfo;
    valueNulls?: Nulls;
    contentNulls?: Nulls;
    required?: boolean;
    defaultValue?: string;
    index?: number;
    description?: string;
}

export interface ConcreteBeanPropertyBase extends BeanProperty, Serializable {
}

export interface TypeBindings extends Serializable {
    empty?: boolean;
    typeParameters?: JavaType[];
}

export interface ResolvedType {
    keyType?: ResolvedType;
    containerType?: boolean;
    arrayType?: boolean;
    concrete?: boolean;
    throwable?: boolean;
    enumType?: boolean;
    collectionLikeType?: boolean;
    mapLikeType?: boolean;
    referencedType?: ResolvedType;
    parameterSource?: Class<any>;
    referenceType?: boolean;
    rawClass?: Class<any>;
    contentType?: ResolvedType;
    interface?: boolean;
    primitive?: boolean;
    final?: boolean;
    abstract?: boolean;
}

export interface HttpEntity<T> {
    headers?: { [index: string]: any };
    body?: T;
}

export interface ConditionReferenceEntity {
    referencedCondition?: string;
}

export interface ConditionReferencedFactEntity {
    type?: string;
    placeholder?: string;
    value?: string;
}

export interface DateTimeExpression<T> extends TemporalExpression<T> {
}

export interface NumberExpression<T> extends ComparableExpressionBase<T> {
}

export interface DslTypesExpression<T> extends Serializable {
    type?: Class<T>;
}

export interface TypeVariable<D> extends Type, AnnotatedElement {
    genericDeclaration?: D;
    annotatedBounds?: AnnotatedType[];
    bounds?: Type[];
    name?: string;
}

export interface CollectionPathBase<C, E, Q> extends CollectionExpressionBase<C, E>, Path<C> {
}

export interface ListExpression<E, Q> extends CollectionExpression<E[], E> {
}

export interface Predicate extends DslTypesExpression<boolean> {
}

export interface EnumExpression<T> extends LiteralExpression<T> {
}

export interface SimpleExpression<T> extends DslExpression<T> {
}

export interface ArrayExpression<A, T> extends DslTypesExpression<A> {
}

export interface ConditionAssociationEntity {
    id?: string;
    condition?: ConditionEntity;
    association?: string;
    type?: string;
    ownerName?: string;
}

export interface QConditionAssociationEntity extends EntityPathBase<ConditionAssociationEntity> {
    association?: StringPath;
    condition?: QConditionEntity;
    id?: StringPath;
    ownerName?: StringPath;
}

export interface SimplePath<T> extends SimpleExpression<T>, Path<T> {
}

export interface QConditionReferenceEntity extends BeanPath<ConditionReferenceEntity> {
    referencedCondition?: StringPath;
}

export interface QConditionReferencedFactEntity extends BeanPath<ConditionReferencedFactEntity> {
    placeholder?: StringPath;
    value?: StringPath;
}

export interface MapExpressionBase<K, V, Q> extends DslExpression<{ [index: string]: V }>, MapExpression<K, V> {
}

export interface ClientApplicationEntity extends Mergable<ClientApplicationEntity>, Serializable {
    name?: string;
    label?: string;
}

export interface TemplateEntity extends Serializable, StandardEntity, NamedObject, Mergable<TemplateEntity>, SolutionAssignedEntity {
    uuid?: string;
    template?: { [index: string]: any };
    metadata?: { [index: string]: any };
    documentType?: string;
    clientApplication?: ClientApplicationEntity;
    templateType?: TemplateTypeEntity;
    dateCreated?: Date;
    dateUpdated?: Date;
    linkedToTemplates?: LinkedPageTemplateEntity[];
    linkedFromTemplates?: LinkedPageTemplateEntity[];
    linkedTraversals?: string[];
    fileCategories?: TemplateFileCategoryAssociation[];
    linkedReferenceLists?: string[];
    conditions?: ConditionAssociationEntity[];
    publishCode?: PublishCode;
    activeHomepage?: ActiveHomepageEntity[];
    active?: boolean;
}

export interface StandardEntity {
    id?: number;
}

export interface BaseVisitor extends ExpressionVisitor {
}

export interface TypeIdResolver {
    descForKnownTypeIds?: string;
    mechanism?: Id;
}

export interface TypeResolutionContext {
}

export interface AnnotationMap extends Annotations {
}

export interface Member {
    modifiers?: number;
    name?: string;
    synthetic?: boolean;
    declaringClass?: Class<any>;
}

export interface Annotated {
    annotated?: AnnotatedElement;
    name?: string;
    public?: boolean;
    type?: JavaType;
    rawType?: Class<any>;
}

export interface MergeInfo {
    getter?: AnnotatedMember;
    fromDefaults?: boolean;
}

export interface BeanProperty extends Named {
    wrapperName?: PropertyName;
    member?: AnnotatedMember;
    fullName?: PropertyName;
    type?: JavaType;
    metadata?: PropertyMetadata;
    required?: boolean;
    virtual?: boolean;
}

export interface Mergable<E> {
    uniqueIdentifier?: string;
}

export interface LiteralExpression<T> extends ComparableExpression<T> {
}

export interface AnnotatedType extends AnnotatedElement {
    annotatedOwnerType?: AnnotatedType;
    type?: Type;
}

export interface EntityPath<T> extends Path<T> {
}

export interface TemplateTypeEntity extends Mergable<TemplateTypeEntity> {
    name?: string;
    label?: string;
}

export interface LinkedPageTemplateEntity extends Serializable {
    pk?: LinkedPageTemplateIdEntity | number;
}

export interface TemplateFileCategoryAssociation extends Serializable {
    documentType?: string;
    categoryName?: string;
}

export interface ExpressionVisitor {
}

export interface Annotations {
}

export interface Named {
    name?: string;
}

export interface TemporalExpression<T> extends LiteralExpression<T> {
}

export interface ComparableExpressionBase<T> extends SimpleExpression<T> {
}

export interface CollectionExpressionBase<T, E> extends DslExpression<T>, CollectionExpression<T, E> {
    elementType?: Class<E>;
}

export interface CollectionExpression<T, E> extends ParameterizedExpression<T> {
}

export interface DslExpression<T> extends DslTypesExpression<T> {
}

export interface MapExpression<K, V> extends ParameterizedExpression<{ [index: string]: V }> {
}

export interface LinkedPageTemplateIdEntity extends Serializable {
    linkedFromTemplate?: TemplateEntity;
    linkedToTemplate?: TemplateEntity;
    traversal?: TraversalDefinitionEntity;
}

export interface ComparableExpression<T> extends ComparableExpressionBase<T> {
}

export interface TraversalDefinitionEntity extends Serializable, SolutionAssignedEntity, Mergable<TraversalDefinitionEntity> {
    id?: number;
    uuid?: string;
    displayName?: string;
    traversal?: { [index: string]: any };
}

export interface ParameterizedExpression<T> extends DslTypesExpression<T> {
}

export type TypeSuffix = "JSON" | "XML";

export type ActionItemType = "subItem" | "labelItem" | "tableItem";

export type ActionTableValueType = "BOOLEAN" | "STRING" | "INTEGER" | "DECIMAL" | "DATE" | "TIMESTAMP" | "TIMESTAMP_WITH_TIME_ZONE" | "JSON" | "HTML" | "REFERENCE_DATA" | "USER_GROUP" | "MIME_TYPE";

export type LabelValueType = "STRING" | "HTML" | "MIME_TYPE";

export type MethodType = "CREATE" | "UPDATE" | "DELETE";

export type PublishItemType = "CONTEXT_MAPPING" | "ENTITY_TYPE" | "FLOW" | "PAGE_TEMPLATE" | "WORKFLOW_TEMPLATE";

export type PublishCode = "OPEN" | "PUBLISHED" | "MODIFIED";

export type Operation = "CREATE" | "UPDATE" | "DELETE" | "OTHER";

export type ItemType = "IMAGE" | "INSIGHT" | "WORKSPACE";

export type LabelType = "DEFAULT" | "REVERSE_REL_NAME";

export type UrnType = "UUID" | "RANDOM_DIGITS" | "SEQUENTIAL";

export type ColumnDataType = "BOOLEAN" | "STRING" | "SMALLINT" | "INTEGER" | "LONG" | "FLOAT" | "DOUBLE" | "NUMERIC" | "DATE" | "TIMESTAMP" | "TIMESTAMP_WITH_TIME_ZONE" | "JSON" | "OTHER";

export type ObjectStateType = "SAVED" | "ENTERED";

export type RuleKeyType = "DATA_OBJECT" | "HOMEPAGE";

export type ExpressionDataType = "STRING" | "NUMBER" | "DATE" | "TIMESTAMP" | "BOOLEAN";

export type PredicateLogicalOperator = "AND" | "OR";

export type SortOrder = "ASC" | "DESC";

export type QueryTableType = "DATA" | "DELETE" | "HISTORY" | "ACTION_HISTORY" | "HISTORY_INFO";

export type PredicateOperator = "EQ" | "IN" | "GT" | "NOT_EQ" | "LTE" | "GTE";

export type QueryExpressionArithmeticOperator = "PLUS" | "MINUS" | "PROD" | "DIV";

export type ConditionalOperator = "EQ" | "NE" | "GT" | "LT" | "GE" | "LE" | "IN" | "NOT_IN" | "BETWEEN" | "IS_NULL" | "IS_NOT_NULL" | "STARTS_WITH" | "ENDS_WITH" | "CONTAINS";

export type FunctionName = "TO_STRING" | "TO_DATE" | "TO_NUMBER" | "UPPERCASE" | "LOWERCASE" | "MOD" | "POW";

export type QueryExpressionLogicalOperator = "AND" | "OR" | "NOT";

export type StringOperator = "CONCAT";

export type AggregateFunctionType = "SUM" | "COUNT" | "AVERAGE" | "MIN" | "MAX";

export type AssignedTimeZone = "DEFAULT" | "AS_STORED";

export type CascadeType = "NONE" | "PERSIST" | "MERGE" | "REMOVE" | "ALL";

export type DataObjectType = "MANAGED" | "SOURCE";

export type DisplayInTimeZone = "DEFAULT" | "AS_STORED" | "LOCAL";

export type IconImageType = "GIF" | "JPEG" | "PNG" | "SVG";

export type IconType = "REGULAR" | "MAP";

export type JobType = "SEARCH_INDEX_LOADER" | "PROCESS_ATTACHMENTS" | "IMPORT_CONFIG";

export type MetadataObjectType = "ICON" | "DOCUMENT" | "LINK" | "TRANSACTION" | "ELEMENT" | "ENTITY" | "TEMPLATE" | "TRAVERSAL" | "CONTROL" | "CONTROL_CATEGORY" | "CONTEXT_MAPPING" | "ACTION" | "ACTION_ITEM" | "REFERENCE_LIST" | "HIERARCHICAL_REFERENCE_DATA" | "CLIENT_APPLICATION" | "TEMPLATE_TYPE" | "CONDITION" | "DATA_STORE" | "SOLUTION" | "ACTIVE_HOMEPAGE";

export type NodeShape = "CIRCLE" | "SQUARE" | "DIAMOND" | "ELLIPSE" | "HEXAGON" | "PENTAGON" | "TRIANGLE";

export type ReferenceListType = "LIST" | "LEVEL";

export type RelationshipCardinality = "ONE_TO_ONE" | "ONE_TO_MANY" | "MANY_TO_ONE" | "MANY_TO_MANY";

export type RelationshipType = "DIRECT_CHILD" | "INDIRECT_CHILD" | "LINK";

export type TaskType = "LOAD_DOCUMENT" | "LOAD_LINK" | "DELETE_INDEX" | "LOAD_TRANSACTION" | "PROCESS_ATTACHMENTS";

export type ConditionAssociationType = "REQUIRED_FIELD" | "READ_ONLY_FIELD" | "TEMPLATE_CONTROL" | "NLD_STYLING" | "CONDITION";

export type ReferencedFactType = "FIELD" | "MEMBERSHIP" | "CONDITION_REFERENCE";

export type EqualityOperator = "eq" | "neq";

export type InequalityOperator = "gt" | "gte" | "lt" | "lte";

export type LogicalOperator = "and" | "or" | "not";

export type MembershipOperator = "current_user_is_member_of" | "current_user_is_not_member_of";

export type PresenceOperator = "empty" | "not_empty";

export type CardinalityStatus = "SATURATED" | "UNSATURATED" | "UNKNOWN";

export type ActionItemState = "ENABLED" | "DISABLED" | "REMOVED";

export type FieldRestrictionRestrictionType = "required" | "readOnly" | "maxLength" | "masked" | "systemReserved" | "fieldDataType" | "precision" | "scale" | "constrainingListName" | "cascadingReferenceDataFilterByCode" | "cascadingReferenceDataFilterByField" | "allowMultipleSelections" | "userSelectionStrategy";

export type RestrictionType = "required" | "requiresDocumentLock" | "allowMultipleFiles";

export type PageMode = "V" | "C" | "E";

export type PageTypeFlag = "STANDARD_PAGE" | "REPLICATED_PAGE";

export type UserGroupType = "user" | "group";

export type UserSelectionStrategyType = "USERS" | "GROUPS" | "USERS_AND_GROUPS";

export type ArithmeticOperator = "equals" | "not_equals";

export type QueryOperatorsLogicalOperator = "and" | "or";

export type CellType = "Live" | "Static" | "Image" | "Text";

export type SheetType = "WORKSHEET" | "NOTESHEET";

export type VisualizationType = "Summary" | "Map" | "Table" | "Timeline" | "Network" | "TextAnalytics";

export type Value = "HOMEPAGE" | "PRINT" | "PAGE";

export type TableType = "managed" | "source";

export type Status = "pending" | "running" | "stopping" | "cancelled" | "completed" | "failed" | "reverted" | "invalid";

export type AccessPattern = "ALWAYS_NULL" | "CONSTANT" | "DYNAMIC";

export type ErrorCode = "DH0100" | "DH0101" | "DH0102" | "DH0103" | "DH0120" | "DH0121" | "DH0122" | "DH0300" | "DH0301" | "DH0302" | "DH0303" | "DH0304" | "DH0305" | "DH0306" | "DH0307" | "DH0400" | "DH1062" | "DH1063" | "DH1070" | "DH1090" | "DH1200" | "DH1202" | "DH1203" | "DH1204" | "DH1205" | "DH1206" | "DH1207" | "DH1208" | "DH1210" | "DH1219" | "DH1220" | "DH1221" | "DH1300" | "DH1310" | "DH1311" | "DH1312" | "DH1313" | "DH1320" | "DH1321" | "DH1354" | "DH1355" | "DH1356" | "DH1357" | "could_not_apply_json_patch_to_document" | "DH1402" | "DH1405" | "DH1406" | "DH1408" | "DH1409" | "DH1410" | "DH1412" | "DH1413" | "DH1414" | "DH1415" | "DH1416" | "DH1418" | "DH1419" | "DH1420" | "DH1501" | "DH1502" | "DH1503" | "DH1506" | "DH1507" | "DH1508" | "DH1509" | "DH1510" | "DH1511" | "DH1512" | "DH1513" | "DH1515" | "DH1517" | "DH1518" | "DH1519" | "DH1520" | "unable_to_serialize_json" | "DH1521" | "DH1522" | "DH1523" | "DH1524" | "DH1525" | "DH1526" | "DH1528" | "DH1529" | "DH1530" | "DH1531" | "DH1532" | "DH1533" | "DH1534" | "DH1535" | "DH1536" | "DH1537" | "DH1538" | "DH1540" | "DH1541" | "DH1544" | "DH1545" | "DH1560" | "DH1561" | "DH1562" | "job_already_running" | "import_config_job_already_running" | "DH1563" | "DH1564" | "DH1565" | "DH1566" | "DH2300" | "DH2301" | "DH2302" | "DH2303" | "DH2304" | "DH2305" | "DH2312" | "DH2313" | "DH2320" | "DH2321" | "DH2322" | "DH2323" | "DH2324" | "DH3000" | "DH3003" | "DH3004" | "DH3005" | "DH3006" | "DH3007" | "DH3010" | "DH3011" | "DH3012" | "DH3013" | "DH3014" | "DH3015" | "DH3016" | "DH3017" | "DH3018" | "DH3019" | "DH3020" | "DH3021" | "DH3022" | "DH3023" | "DH3024" | "DH3025" | "DH3026" | "DH3027" | "DH3029" | "DH3030" | "DH3031" | "DH3032" | "DH3033" | "DH3035" | "DH3065" | "DH3066" | "DH3067" | "DH3068" | "DH3070" | "DH3071" | "DH3072" | "DH3073" | "DH3076" | "DH3077" | "DH3078" | "DH3079" | "data_store_credential_create_op_failed" | "data_store_credential_read_op_failed" | "data_store_credential_update_op_failed" | "data_store_credential_delete_op_failed" | "data_store_credential_delete_op_unauthorized" | "data_store_internal_property_not_found" | "data_store_internal_resolved_property_not_found" | "DH3080" | "DH3081" | "DH3082" | "DH3083" | "DH3084" | "DH3085" | "DH3086" | "DH3087" | "DH3088" | "DH3089" | "DH3090" | "DH3100" | "DH3101" | "DH3102" | "DH3103" | "DH3105" | "DH3106" | "DH3107" | "DH3108" | "DH3109" | "DH3110" | "DH3112" | "DH3113" | "DH3114" | "DH3115" | "DH3116" | "DH3118" | "DH3119" | "DH3120" | "DH3122" | "DH3123" | "DH3124" | "DH3125" | "DH3126" | "DH3127" | "DH3129" | "DH3130" | "DH3132" | "DH3133" | "DH3135" | "DH3137" | "DH3138" | "DH3139" | "DH3140" | "DH3141" | "DH3142" | "DH3145" | "DH3146" | "DH3147" | "DH3148" | "DH3150" | "DH3151" | "DH3152" | "DH3153" | "DH3154" | "DH3155" | "DH3156" | "DH3157" | "DH3158" | "missing_primary_key_field_for_transaction" | "DH3160" | "DH3161" | "DH3162" | "DH3163" | "DH3164" | "DH3165" | "DH3166" | "DH3167" | "DH3168" | "DH3169" | "DH3170" | "DH3171" | "DH3172" | "DH3175" | "DH3176" | "DH3177" | "DH3178" | "DH3179" | "DH3180" | "DH3181" | "DH3182" | "DH3183" | "DH3184" | "DH3185" | "DH3186" | "DH3187" | "DH3188" | "DH3189" | "DH3190" | "DH3191" | "DH3192" | "DH3193" | "DH3194" | "DH3195" | "DH3196" | "DH3197" | "DH3198" | "DH3199" | "DH3200" | "DH3201" | "DH3202" | "DH3203" | "DH3205" | "DH3206" | "DH3207" | "DH3208" | "DH3209" | "DH3210" | "DH3211" | "DH3212" | "DH3213" | "DH3214" | "DH3215" | "DH3216" | "DH3217" | "DH3218" | "DH3219" | "DH3220" | "DH3221" | "DH3222" | "DH3223" | "DH3224" | "DH3225" | "DH3226" | "DH3227" | "DH3228" | "DH3229" | "DH3230" | "DH3231" | "DH3232" | "DH3238" | "DH3240" | "DH3261" | "DH3264" | "DH3266" | "DH3267" | "DH3268" | "DH3269" | "DH3272" | "DH3273" | "DH3274" | "DH3275" | "DH3276" | "DH3278" | "DH3279" | "DH3280" | "DH3281" | "DH3282" | "DH3283" | "DH3284" | "DH3285" | "DH3286" | "DH3287" | "DH3288" | "DH3289" | "DH3290" | "DH3291" | "DH3294" | "DH3295" | "DH3296" | "DH3298" | "DH3299" | "DH3300" | "DH3302" | "DH3303" | "DH3304" | "incompatibleColumnDataTypeForConstrainedExternalField" | "DH3310" | "DH3311" | "DH3312" | "DH3313" | "DH3320" | "DH3321" | "DH3324" | "DH3330" | "DH3338" | "DH3339" | "DH3340" | "DH3341" | "DH3342" | "DH3343" | "DH3344" | "DH3345" | "DH3346" | "DH3347" | "DH3348" | "DH3349" | "DH3351" | "DH3352" | "DH3353" | "DH3354" | "DH3355" | "DH3356" | "DH3357" | "DH3358" | "DH3359" | "DH3360" | "DH3361" | "DH3362" | "DH3363" | "DH3364" | "DH3365" | "DH3369" | "DH3380" | "DH3381" | "DH3382" | "DH3400" | "DH3401" | "DH3402" | "DH3404" | "DH3405" | "DH3414" | "DH3419" | "DH3420" | "DH3422" | "DH3424" | "DH3425" | "DH3426" | "DH3427" | "DH3428" | "DH3429" | "DH3430" | "DH3431" | "DH3432" | "DH3433" | "DH3440" | "DH3441" | "DH3442" | "DH3443" | "DH3444" | "DH3445" | "DH3446" | "DH3447" | "DH3448" | "DH3450" | "DH3451" | "DH3452" | "DH3453" | "DH3454" | "DH3455" | "DH3456" | "DH3466" | "DH3470" | "DH3471" | "DH3472" | "DH3473" | "DH3474" | "DH3475" | "DH3476" | "DH3477" | "DH3478" | "DH3479" | "DH3480" | "DH3481" | "DH3482" | "DH3483" | "DH3484" | "DH3486" | "DH3487" | "DH3488" | "DH3489" | "DH3490" | "DH3491" | "DH3492" | "DH3493" | "DH3494" | "DH3495" | "DH3497" | "DH3498" | "DH3500" | "DH3501" | "DH3502" | "DH3503" | "DH3504" | "DH3505" | "DH3506" | "DH3507" | "DH3508" | "DH3509" | "DH3510" | "publishCodeCannotBeModifiedForContextMapping" | "invalid_client_application" | "DH3511" | "DH3512" | "DH3513" | "DH3514" | "DH3515" | "DH3516" | "DH3517" | "userGroupMembershipOperatorCanOnlyBeUsedForUserGroupChooserFields" | "userGroupMembershipOperatorMustReferenceFieldOrValueButNotBoth" | "DH3520" | "DH3600" | "DH3601" | "DH3602" | "DH3620" | "DH3621" | "DH3650" | "DH3651" | "DH3652" | "DH3653" | "DH3654" | "DH3655" | "DH3700" | "DH3701" | "DH3702" | "DH3703" | "DH3704" | "DH3705" | "DH3706" | "DH3708" | "DH3709" | "DH3710" | "DH3711" | "DH3712" | "DH3713" | "DH3714" | "DH3715" | "DH3716" | "DH3717" | "DH3718" | "DH3719" | "DH3720" | "DH3721" | "DH3723" | "DH3724" | "DH3725" | "DH3726" | "DH3727" | "DH3728" | "DH3729" | "DH3730" | "DH3731" | "DH3732" | "DH3733" | "DH3734" | "DH3735" | "DH3736" | "DH3737" | "DH3738" | "DH3739" | "DH3740" | "DH3741" | "DH3742" | "DH3743" | "DH3744" | "DH4100" | "DH4101" | "DH4102" | "DH4103" | "DH4114" | "DH4116" | "DH4120" | "DH4129" | "DH4130" | "DH4131" | "DH4132" | "DH4133" | "DH4134" | "DH4135" | "DH4136" | "DH4137" | "DH4138" | "DH4139" | "DH4140" | "DH4141" | "DH4142" | "DH4143" | "DH4144" | "DH4145" | "DH4150" | "DH4151" | "DH4152" | "DH4153" | "DH4154" | "DH4155" | "DH4156" | "DH4157" | "DH4158" | "DH4159" | "DH4160" | "DH4162" | "DH4163" | "column_not_found_for_heterogeneous_link_field" | "DH4167" | "DH4168" | "rel_child_must_ref_parent_by_pk" | "DH4169" | "DH4170" | "DH4173" | "DH4174" | "DH4175" | "DH4179" | "DH4180" | "DH4181" | "DH4182" | "DH4183" | "DH4184" | "DH4185" | "DH4186" | "DH4187" | "DH4188" | "DH4189" | "DH4190" | "DH4191" | "DH4192" | "DH4193" | "DH4194" | "DH4200" | "DH4201" | "DH4202" | "DH4203" | "DH4207" | "DH4208" | "DH4211" | "DH4220" | "DH4221" | "DH4222" | "DH4223" | "DH4224" | "DH4225" | "DH4226" | "DH4227" | "DH4228" | "DH4229" | "DH4302" | "DH4332" | "DH4304" | "DH4305" | "DH4310" | "DH4331" | "DH4316" | "DH4317" | "DH4319" | "DH4320" | "DH4321" | "DH4322" | "DH4328" | "DH4330" | "DH4338" | "DH4343" | "DH4346" | "DH4347" | "DH4350" | "DH4351" | "DH4400" | "DH4401" | "DH4402" | "DH4403" | "DH4404" | "DH5100" | "DH5101" | "DH5102" | "DH5103" | "DH5104" | "DH5105" | "DH5107" | "DH5108" | "DH5109" | "DH5111" | "DH5112" | "DH5114" | "DH5115" | "DH5116" | "DH5118" | "DH5119" | "DH5120" | "DH5121" | "DH5122" | "DH5123" | "DH5125" | "DH5126" | "DH5127" | "DH5128" | "DH5129" | "DH5130" | "DH5131" | "DH5133" | "DH5134" | "DH5135" | "DH5200" | "DH5201" | "DH5202" | "DH5203" | "DH5204" | "DH5205" | "DH5206" | "DH5207" | "DH5210" | "DH5211" | "DH5212" | "DH5213" | "DH5500" | "DH5501" | "DH5502" | "DH5503" | "DH5504" | "DH5505" | "DH5506" | "DH5507" | "import_database_error" | "import_database_error_for_type" | "export_failed" | "DH5600" | "DH5601" | "DH5602" | "DH5603" | "DH6099" | "DH6100" | "DH6101" | "DH6102" | "DH6103" | "DH6104" | "DH6105" | "stored_objects_with_names_not_found" | "DH6106" | "DH6107" | "DH6108" | "DH6109" | "entity_does_not_have_relationship" | "DH6110" | "DH6112" | "DH6113" | "DH6114" | "DH6116" | "DH6118" | "DH6119" | "DH6120" | "DH6122" | "DH6123" | "DH6124" | "DH6125" | "DH6126" | "DH6127" | "DH6128" | "DH6129" | "DH6131" | "DH6132" | "DH6133" | "DH6134" | "DH6135" | "DH6136" | "DH6137" | "DH6138" | "DH6139" | "DH6140" | "DH6141" | "DH6142" | "DH6143" | "DH6144" | "DH6145" | "DH6146" | "DH6147" | "DH6148" | "DH6149" | "DH6150" | "DH6151" | "DH6152" | "DH6153" | "DH6154" | "DH6155" | "DH6156" | "DH6157" | "DH6158" | "DH6159" | "DH6160" | "DH6161" | "DH6162" | "DH6163" | "DH6164" | "DH6165" | "DH6166" | "DH6167" | "DH6168" | "DH6169" | "DH6170" | "DH6171" | "DH6172" | "DH6173" | "DH6174" | "DH6175" | "DH6176" | "DH6177" | "DH6178" | "DH6179" | "DH6180" | "DH6181" | "DH6182" | "DH6183" | "DH6184" | "DH6185" | "DH6186" | "DH6187" | "DH6188" | "DH6189" | "DH6191" | "DH6198" | "DH6199" | "DH6200" | "DH6201" | "DH6202" | "DH6203" | "DH6205" | "DH6206" | "DH6207" | "DH6208" | "DH6209" | "DH6210" | "DH6211" | "DH6212" | "DH6213" | "DH6214" | "DH6215" | "DH6216" | "DH6217" | "DH6218" | "DH6219" | "DH6220" | "DH6221" | "DH6222" | "DH6223" | "DH6224" | "DH6225" | "DH6226" | "tuning_global_parameters_must_be_supplied" | "tuning_parameters_property_cannot_be_empty" | "tuning_object_type_and_name_must_match_when_global_type" | "tuning_maximum_parameters_exceeded" | "tuning_no_parameters_supplied" | "value_must_be_supplied_for_tuning_parameter" | "invalid_tuning_parameter_name_supplied" | "tuning_parameter_values_must_be_greater_than_zero" | "tuning_parameter_cannot_have_decimal_value" | "tuning_non_global_values_cannot_have_default_values" | "global_default_values_cannot_be_updated" | "DH6300" | "DH6301" | "DH6302" | "DH6303" | "DH6304" | "DH6310" | "DH6311" | "DH6350" | "DH6351" | "DH6352" | "DH6353" | "DH6354" | "DH6356" | "DH6357" | "DH6358" | "DH6360" | "DH6361" | "DH6362" | "DH6363" | "DH6364" | "DH6365" | "DH6366" | "DH6380" | "DH6381" | "DH6382" | "DH6383" | "DH6900" | "DH6901" | "DH6902" | "DH6903" | "DH6904" | "DH6905" | "DH6907" | "DH6910" | "DH6911" | "DH6912" | "DH6913" | "DH6914" | "DH6915" | "DH6916" | "DH6917" | "DH6918" | "not_a_valid_entity_date_field_w_id" | "not_a_valid_entity_timestamp_w_id" | "not_a_valid_entity_date_field_without_id" | "not_a_valid_entity_timestamp_without_id" | "not_a_valid_relationship_entity_date_field_w_id" | "not_a_valid_relationship_entity_timestamp_w_id" | "not_a_valid_relationship_entity_date_field_without_id" | "not_a_valid_relationship_entity_timestamp_without_id" | "DH6919" | "DH6920" | "DH6921" | "DH6922" | "DH6923" | "DH6998" | "DH6999" | "DH7000" | "DH7001" | "DH7002" | "DH7003" | "DH7004" | "DH7005" | "DH7006" | "DH7008" | "DH7009" | "DH7010" | "DH7011" | "DH7012" | "DH7013" | "DH7014" | "DH7100" | "DH7101" | "DH7102" | "DH7103" | "DH7104" | "DH7105" | "DH7106" | "DH7107" | "DH7108" | "DH7109" | "DH7110" | "DH9000" | "DH9001" | "DH9003" | "DH9004" | "DH9005" | "DH9006" | "DH9010" | "DH9011" | "DH9012" | "DH9013" | "DH9016" | "DH9017" | "DH9032" | "DH9034" | "DH9035" | "DH9036" | "DH9037" | "DH9040" | "DH9041" | "DH9042" | "DH9043" | "DH9044" | "solutionMustHaveUniqueName" | "solutionWithNameNotFound" | "solutionNameCannotBeChanged" | "solutionMustHaveUniqueNameArchivedClash" | "solutionCannotBeCreatedAsArchived" | "solutionArchivedCannotBeUpdated" | "solutionResourceVersionMustBeNullOr0OnCreate" | "solutionCannotBeArchivedThroughUpdate" | "solutionImportDuplicateLabel" | "solutionNameMustBeSet" | "solutionArchivedCannotBeAssigned" | "solutionArchivedCannotBePublished" | "solutionChildObjectMustBeAssignedToSameSolutionAsParentObject" | "solutionCannotBeArchivedAsAtLeastOneSolutionMustBeUnarchived" | "activeHomepageClientApplicationDoesNotExist" | "activeHomepageTemplateDoesNotExist" | "activeHomepageClientApplicationMismatch" | "activeHomepageWrongTemplateType" | "activeHomepageAlreadySetForClientApplication" | "activeHomepageNotFound" | "activeHomepageCannotDelete" | "activeHomepageUpdateIdMismatch" | "activeHomepageUpdateRequestIdMismatch" | "activeHomepageAlreadyExistsForClientApplication" | "activeHomepageDoesNotExistForClientApplication" | "activeHomepageCanOnlyBeChangedThroughTemplateUpsertWhenImport" | "noMatchingRulesForKey" | "contextMappingUuidMismatch" | "contextMappingInvalidUuid" | "contextMappingEntityOrClientMismatch" | "dataHubClientError" | "DH15000" | "DH15001" | "DH15002" | "DH15003" | "DH15004" | "DH17000" | "DH17001" | "invalid_job_json" | "authorized_to_reveal_masked_length" | "authorized_to_reveal_masked_should_be_null" | "authorized_to_reveal_masked_should_have_contents" | "authorized_to_reveal_masked_cannot_be_primary_key_field" | "user_group_not_authorized_to_reveal_masked_field" | "file_is_quarantined" | "invalid_rest_api_parameter" | "invalid_rest_api_body";

export type DataStoreType = "RELATIONAL";

export type TYPE = "internal_postgres" | "postgres" | "oracle" | "teradata" | "db2" | "MySQL" | "SQL Server";

export type MessageAction = "CREATE" | "UPDATE" | "DELETE";

export type CommonsSecurityBootStrapModelTypesUserGroupType = "user" | "group";

export type AccessType = "create" | "read" | "update" | "delete" | "search";

export type HttpStatus = "100 CONTINUE" | "101 SWITCHING_PROTOCOLS" | "102 PROCESSING" | "103 CHECKPOINT" | "200 OK" | "201 CREATED" | "202 ACCEPTED" | "203 NON_AUTHORITATIVE_INFORMATION" | "204 NO_CONTENT" | "205 RESET_CONTENT" | "206 PARTIAL_CONTENT" | "207 MULTI_STATUS" | "208 ALREADY_REPORTED" | "226 IM_USED" | "300 MULTIPLE_CHOICES" | "301 MOVED_PERMANENTLY" | "302 FOUND" | "302 MOVED_TEMPORARILY" | "303 SEE_OTHER" | "304 NOT_MODIFIED" | "305 USE_PROXY" | "307 TEMPORARY_REDIRECT" | "308 PERMANENT_REDIRECT" | "400 BAD_REQUEST" | "401 UNAUTHORIZED" | "402 PAYMENT_REQUIRED" | "403 FORBIDDEN" | "404 NOT_FOUND" | "405 METHOD_NOT_ALLOWED" | "406 NOT_ACCEPTABLE" | "407 PROXY_AUTHENTICATION_REQUIRED" | "408 REQUEST_TIMEOUT" | "409 CONFLICT" | "410 GONE" | "411 LENGTH_REQUIRED" | "412 PRECONDITION_FAILED" | "413 PAYLOAD_TOO_LARGE" | "413 REQUEST_ENTITY_TOO_LARGE" | "414 URI_TOO_LONG" | "414 REQUEST_URI_TOO_LONG" | "415 UNSUPPORTED_MEDIA_TYPE" | "416 REQUESTED_RANGE_NOT_SATISFIABLE" | "417 EXPECTATION_FAILED" | "418 I_AM_A_TEAPOT" | "419 INSUFFICIENT_SPACE_ON_RESOURCE" | "420 METHOD_FAILURE" | "421 DESTINATION_LOCKED" | "422 UNPROCESSABLE_ENTITY" | "423 LOCKED" | "424 FAILED_DEPENDENCY" | "425 TOO_EARLY" | "426 UPGRADE_REQUIRED" | "428 PRECONDITION_REQUIRED" | "429 TOO_MANY_REQUESTS" | "431 REQUEST_HEADER_FIELDS_TOO_LARGE" | "451 UNAVAILABLE_FOR_LEGAL_REASONS" | "500 INTERNAL_SERVER_ERROR" | "501 NOT_IMPLEMENTED" | "502 BAD_GATEWAY" | "503 SERVICE_UNAVAILABLE" | "504 GATEWAY_TIMEOUT" | "505 HTTP_VERSION_NOT_SUPPORTED" | "506 VARIANT_ALSO_NEGOTIATES" | "507 INSUFFICIENT_STORAGE" | "508 LOOP_DETECTED" | "509 BANDWIDTH_LIMIT_EXCEEDED" | "510 NOT_EXTENDED" | "511 NETWORK_AUTHENTICATION_REQUIRED";

export type PathType = "ARRAYVALUE" | "ARRAYVALUE_CONSTANT" | "COLLECTION_ANY" | "DELEGATE" | "LISTVALUE" | "LISTVALUE_CONSTANT" | "MAPVALUE" | "MAPVALUE_CONSTANT" | "PROPERTY" | "VARIABLE";

export type As = "PROPERTY" | "WRAPPER_OBJECT" | "WRAPPER_ARRAY" | "EXTERNAL_PROPERTY" | "EXISTING_PROPERTY";

export type Nulls = "SET" | "SKIP" | "FAIL" | "AS_EMPTY" | "DEFAULT";

export type Id = "NONE" | "CLASS" | "MINIMAL_CLASS" | "NAME" | "CUSTOM";

export type DataContentUnion = DocumentIdentifier | Document | DocumentLink | DataResolvedEntity;

export type AbstractFileOperationUnion = CreateFileOperation | UpdateFileOperation | DeleteFileOperation;

export type JobFilterUnion = IncrementalLoadJobFilter;

export type BooleanExpressionUnion = ConditionalExpression | LogicalExpression;

export type ExpressionUnion = FieldReference | Literal | NamedParameter | StringExpression | BooleanExpression | FunctionCall | ArithmeticExpression;

export type AbstractConditionUnion = CompositeCondition | PresenceCondition | ArithmeticCondition | NegateCondition | CurrentUserMembershipCondition | ReferencedCondition;

export type QueryUnion = CompositeQuery | ArithmeticQuery | CurrentUserMembershipQuery;

export type AbstractRedactionRuleUnion = FullRedactionRule;

export type CellUnion = LiveVisualizationCell | StaticVisualizationCell | ImageCell | TextCell;
