/**
 * This is the set of from and to events that is used to
 * build the histogram within the time slider.
 */
export interface TimeSliderEventDates {
    fromEvents: Date[];
    toEvents: Date[];
}
export declare enum DateTimeInterval {
    Second = "second",
    Minute = "minute",
    Hour = "hour",
    Day = "day",
    Week = "week",
    Month = "month",
    Year = "year",
    Quarter = "qtr",
    Millisecond = "millisecond"
}
export declare enum HandleType {
    Single = 1,
    Double = 2
}
/**
 * The time-slider.component.ts uses a single or double handled slider
 * to specify a range of dates. This interface is the data associated
 * with that range. It accommodates a single or double handled range.
 *
 * For a single handled slider, the start and end dates are the same.
 *
 */
export interface TimeSliderRange {
    start?: Date;
    end?: Date;
}
export interface TimeSliderContextMenuHideOptions {
    pointInTime?: boolean;
    timeRange?: boolean;
    showHistogram?: boolean;
    closeTimeSlider?: boolean;
}
export interface MinMaxDates {
    min: Date;
    max: Date;
}
export interface TimeSliderRangeChangedEvent {
    start: Date;
    end: Date;
    rangeChangedOutsideTimeSlider: boolean;
}
